"use strict";
var BaseFunctionBinder = (function () {
    function BaseFunctionBinder(baseDefinitionBinder, namedBinder, typeParameterBinder, parameterBinder, returnTypedBinder) {
        this.baseDefinitionBinder = baseDefinitionBinder;
        this.namedBinder = namedBinder;
        this.typeParameterBinder = typeParameterBinder;
        this.parameterBinder = parameterBinder;
        this.returnTypedBinder = returnTypedBinder;
    }
    BaseFunctionBinder.prototype.bind = function (def) {
        this.baseDefinitionBinder.bind(def);
        this.namedBinder.bind(def);
        this.typeParameterBinder.bind(def);
        this.parameterBinder.bind(def);
        this.returnTypedBinder.bind(def);
        if (def.parameters.length > 0 && def.parameters[0].name === "this") {
            var thisParam = def.parameters.splice(0, 1)[0];
            def.thisType = thisParam.type;
        }
        def.isGenerator = this.getIsGenerator();
        (_a = def.overloadSignatures).push.apply(_a, this.getOverloadSignatures());
        def.userDefinedTypeGuard = this.getUserDefinedTypeGuard();
        if (def.userDefinedTypeGuard != null) {
            def.returnType.text = (def.userDefinedTypeGuard.parameterName || "this") + " is " + def.userDefinedTypeGuard.type.text;
        }
        var _a;
    };
    return BaseFunctionBinder;
}());
exports.BaseFunctionBinder = BaseFunctionBinder;

//# sourceMappingURL=BaseFunctionBinder.js.map
