"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var base_1 = require("./../../base");
var TsBaseDefinitionBinder_1 = require("./TsBaseDefinitionBinder");
var TsNamedBinder_1 = require("./TsNamedBinder");
var TsTypeParameteredBinderByNode_1 = require("./TsTypeParameteredBinderByNode");
var TsParameteredBinderByNode_1 = require("./TsParameteredBinderByNode");
var TsReturnTypedBinderByNode_1 = require("./TsReturnTypedBinderByNode");
var TsBaseFunctionBinder = (function (_super) {
    __extends(TsBaseFunctionBinder, _super);
    function TsBaseFunctionBinder(factory, node, paramDefinition, paramBinder) {
        _super.call(this, new TsBaseDefinitionBinder_1.TsBaseDefinitionBinder(), new TsNamedBinder_1.TsNamedBinder(node), new TsTypeParameteredBinderByNode_1.TsTypeParameteredBinderByNode(factory, node), new TsParameteredBinderByNode_1.TsParameteredBinderByNode(factory, node, paramDefinition, paramBinder), new TsReturnTypedBinderByNode_1.TsReturnTypedBinderByNode(factory, node));
        this.factory = factory;
        this.node = node;
    }
    TsBaseFunctionBinder.prototype.getIsGenerator = function () {
        return this.node.isGeneratorFunction();
    };
    TsBaseFunctionBinder.prototype.getOverloadSignatures = function () {
        var _this = this;
        var callSignatures = this.node.getType().getCallSignatures().filter(function (c) { return !c.getDeclaration().hasFunctionBody(); });
        // we need to ignore the implementation signature in these cases
        if (this.node.isMethodSignature() || this.node.isAmbient() || this.node.hasAbstractKeyword()) {
            callSignatures.pop();
        }
        return callSignatures.map(function (s) { return _this.factory.getCallSignatureFromSignature(s); });
    };
    TsBaseFunctionBinder.prototype.getUserDefinedTypeGuard = function () {
        var userDefinedTypeGuard = null;
        for (var _i = 0, _a = this.node.getChildren(); _i < _a.length; _i++) {
            var node = _a[_i];
            if (node.isUserDefinedTypeGuard()) {
                userDefinedTypeGuard = this.factory.getUserDefinedTypeGuardFromNode(node);
                break;
            }
        }
        return userDefinedTypeGuard;
    };
    return TsBaseFunctionBinder;
}(base_1.BaseFunctionBinder));
exports.TsBaseFunctionBinder = TsBaseFunctionBinder;

//# sourceMappingURL=TsBaseFunctionBinder.js.map
