"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var utils_1 = require("./../../../utils");
var base_1 = require("./../../base");
var TsModuledBinder = (function (_super) {
    __extends(TsModuledBinder, _super);
    function TsModuledBinder(factory, node) {
        _super.call(this);
        this.factory = factory;
        this.node = node;
    }
    TsModuledBinder.prototype.getMembers = function () {
        var _this = this;
        var members = [];
        // because there can be multiple function signatures, the last one needs to be used
        var currentFunction;
        this.node.getChildren().forEach(function (childNode) {
            utils_1.tryGet(childNode, function () {
                if (currentFunction != null && (!childNode.isFunction() || childNode.getName() !== currentFunction.name)) {
                    members.push(_this.factory.getDefinitionByNode(currentFunction.node));
                    currentFunction = undefined;
                }
                if (childNode.isFunction()) {
                    currentFunction = { name: childNode.getName(), node: childNode };
                    return;
                }
                var def = _this.factory.getDefinitionByNode(childNode);
                if (def == null) {
                    var symbol = _this.node.getSymbol();
                    var isKnownTypeToIgnore = (symbol != null && symbol.isDefaultExport()) ||
                        childNode.isExportDeclaration() ||
                        childNode.isExportAssignment() ||
                        childNode.isImport();
                    if (!isKnownTypeToIgnore) {
                        utils_1.Logger.warn("Node is not handled for: " + childNode.getName());
                    }
                }
                else {
                    members.push(def);
                }
            });
        });
        if (currentFunction != null) {
            utils_1.tryGet(currentFunction.node, function () {
                members.push(_this.factory.getDefinitionByNode(currentFunction.node));
            });
        }
        return members;
    };
    return TsModuledBinder;
}(base_1.ModuledBinder));
exports.TsModuledBinder = TsModuledBinder;

//# sourceMappingURL=TsModuledBinder.js.map
