"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var base_1 = require("./../../../base");
var TsExpressionBinder_1 = require("./../TsExpressionBinder");
var TsBaseTypeBinderByType = (function (_super) {
    __extends(TsBaseTypeBinderByType, _super);
    function TsBaseTypeBinderByType(factory, tsType) {
        _super.call(this, new TsExpressionBinder_1.TsExpressionBinder(tsType));
        this.factory = factory;
        this.tsType = tsType;
        this.getCallSignatureAndProperties = tsType.isAnonymousType() && !tsType.isReferenceType() &&
            !tsType.isClassType() && !tsType.isInterfaceType() && !tsType.isUnionType() && !tsType.isIntersectionType() &&
            !tsType.isTupleType();
        this.text = tsType.getText() || "";
    }
    TsBaseTypeBinderByType.prototype.isArrayType = function () {
        return this.tsType.isArrayType();
    };
    TsBaseTypeBinderByType.prototype.getArrayElementType = function () {
        var tsType = this.tsType.getArrayElementType();
        return tsType == null ? null : this.factory.getType(tsType, null);
    };
    TsBaseTypeBinderByType.prototype.isIntersectionType = function () {
        return this.tsType.isIntersectionType() && this.text.indexOf("&") > 0;
    };
    TsBaseTypeBinderByType.prototype.isUnionType = function () {
        return this.tsType.isUnionType() && this.text.indexOf("|") > 0;
    };
    TsBaseTypeBinderByType.prototype.getUnionOrIntersectionTypes = function () {
        var _this = this;
        return this.tsType.getUnionOrIntersectionTypes().map(function (t) { return _this.factory.getType(t, null); });
    };
    TsBaseTypeBinderByType.prototype.getProperties = function () {
        var _this = this;
        if (this.getCallSignatureAndProperties) {
            return this.tsType.getProperties().map(function (p) { return _this.factory.getTypePropertyFromSymbol(p); });
        }
        else {
            return [];
        }
    };
    TsBaseTypeBinderByType.prototype.getTypeArguments = function () {
        var _this = this;
        return this.tsType.getTypeArguments().map(function (arg) { return _this.factory.getType(arg, null); });
    };
    return TsBaseTypeBinderByType;
}(base_1.BaseTypeBinder));
exports.TsBaseTypeBinderByType = TsBaseTypeBinderByType;

//# sourceMappingURL=TsBaseTypeBinderByType.js.map
