"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var base_1 = require("./../../../base");
var TsExpressionBinder_1 = require("./../TsExpressionBinder");
var TsBaseTypeBinderByTypeNode = (function (_super) {
    __extends(TsBaseTypeBinderByTypeNode, _super);
    function TsBaseTypeBinderByTypeNode(factory, tsTypeNode) {
        _super.call(this, new TsExpressionBinder_1.TsExpressionBinder(tsTypeNode));
        this.factory = factory;
        this.tsTypeNode = tsTypeNode;
    }
    TsBaseTypeBinderByTypeNode.prototype.isArrayType = function () {
        return this.tsTypeNode.isArrayTypeNode();
    };
    TsBaseTypeBinderByTypeNode.prototype.getArrayElementType = function () {
        var tsNode = this.tsTypeNode.getArrayElementTypeNode();
        return tsNode == null ? null : this.factory.getTypeFromTypeNode(tsNode);
    };
    TsBaseTypeBinderByTypeNode.prototype.isIntersectionType = function () {
        return this.tsTypeNode.isIntersectionType();
    };
    TsBaseTypeBinderByTypeNode.prototype.isUnionType = function () {
        return this.tsTypeNode.isUnionType();
    };
    TsBaseTypeBinderByTypeNode.prototype.getUnionOrIntersectionTypes = function () {
        var _this = this;
        return this.tsTypeNode.getUnionOrIntersectionTypeNodes().map(function (t) { return _this.factory.getTypeFromTypeNode(t); });
    };
    TsBaseTypeBinderByTypeNode.prototype.getProperties = function () {
        var _this = this;
        return this.tsTypeNode.getMemberNodes().map(function (p) { return _this.factory.getTypePropertyFromNode(p); });
    };
    TsBaseTypeBinderByTypeNode.prototype.getTypeArguments = function () {
        var _this = this;
        return this.tsTypeNode.getTypeArgumentsTypeNodes().map(function (arg) { return _this.factory.getTypeFromTypeNode(arg); });
    };
    return TsBaseTypeBinderByTypeNode;
}(base_1.BaseTypeBinder));
exports.TsBaseTypeBinderByTypeNode = TsBaseTypeBinderByTypeNode;

//# sourceMappingURL=TsBaseTypeBinderByTypeNode.js.map
