"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var base_1 = require("./../../base");
var base_2 = require("./../base");
var TsFileBinder = (function (_super) {
    __extends(TsFileBinder, _super);
    function TsFileBinder(factory, sourceFile) {
        _super.call(this, new base_2.TsBaseDefinitionBinder(), new base_2.TsModuledBinder(factory, sourceFile.getNode()));
        this.factory = factory;
        this.sourceFile = sourceFile;
    }
    TsFileBinder.prototype.getFileName = function () {
        return this.sourceFile.getFileName();
    };
    TsFileBinder.prototype.getDefaultExportExpression = function () {
        var symbol = this.sourceFile.getDefaultExportSymbol();
        if (symbol != null) {
            return this.factory.getExpressionFromExportSymbol(symbol);
        }
        else {
            return null;
        }
    };
    TsFileBinder.prototype.getImports = function () {
        // binding handled in FileBinder
        return [];
    };
    TsFileBinder.prototype.getReExports = function () {
        // binding handled in FileBinder
        return [];
    };
    return TsFileBinder;
}(base_1.FileBinder));
exports.TsFileBinder = TsFileBinder;

//# sourceMappingURL=TsFileBinder.js.map
