"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var base_1 = require("./../../base");
var base_2 = require("./../base");
var TsReExportBinder = (function (_super) {
    __extends(TsReExportBinder, _super);
    function TsReExportBinder(factory, node) {
        _super.call(this, new base_2.TsBaseDefinitionBinder());
        this.factory = factory;
        this.node = node;
    }
    TsReExportBinder.prototype.getFileName = function () {
        return this.node.getFileNameOfModuleSpecifier() || "";
    };
    TsReExportBinder.prototype.getModuleSpecifier = function () {
        return this.node.getModuleSpecifierText() || "";
    };
    TsReExportBinder.prototype.getIsStarExport = function () {
        var symbol = this.node.getSymbol();
        return symbol != null && symbol.isExportStar();
    };
    TsReExportBinder.prototype.getNamedExports = function () {
        var _this = this;
        return this.node.getReExportNamedExportNodes().map(function (node) { return _this.factory.getNamedImportPart(node); });
    };
    TsReExportBinder.prototype.getStarExports = function () {
        var _this = this;
        var moduleSymbol = this.node.getModuleSpecifierSymbol();
        var starExportSymbols = moduleSymbol == null ? {} : moduleSymbol.getExportSymbolsByName();
        return Object.keys(starExportSymbols).filter(function (name) { return name !== "default"; }).map(function (name) {
            var _a = _this.factory.getDefinitionsOrExpressionFromExportSymbol(starExportSymbols[name]), definitions = _a.definitions, expression = _a.expression;
            return _this.factory.getStarImportPart({
                name: name,
                definitions: definitions,
                expression: expression
            });
        });
    };
    return TsReExportBinder;
}(base_1.ReExportBinder));
exports.TsReExportBinder = TsReExportBinder;

//# sourceMappingURL=TsReExportBinder.js.map
