"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var utils_1 = require("./../../../utils");
var base_1 = require("./../../base");
var base_2 = require("./../base");
var TsInterfaceBinder = (function (_super) {
    __extends(TsInterfaceBinder, _super);
    function TsInterfaceBinder(factory, node) {
        _super.call(this, new base_2.TsBaseDefinitionBinder(), new base_2.TsNamedBinder(node), new base_2.TsExportableBinder(node), new base_2.TsAmbientableBinder(node), new base_2.TsTypeParameteredBinderByNode(factory, node));
        this.factory = factory;
        this.node = node;
    }
    TsInterfaceBinder.prototype.getExtendsTypes = function () {
        var _this = this;
        return this.node.getChildren()
            .filter(function (node) { return node.isHeritageClause() && node.hasExtendsKeyword(); })
            .map(function (node) { return node.getHeritageTypeNodes(); })
            .reduce(function (a, b) { return a.concat(b); }, [])
            .map(function (typeNode) { return _this.factory.getTypeFromTypeNode(typeNode); });
    };
    TsInterfaceBinder.prototype.getMembers = function () {
        var _this = this;
        var container = new base_1.InterfaceMemberContainer();
        // because there can be multiple method signatures, the last one needs to be used
        var methods = {};
        this.node.getChildren().forEach(function (childNode) {
            utils_1.tryGet(childNode, function () {
                if (childNode.isMethodSignature()) {
                    methods[childNode.getName()] = childNode;
                }
                else if (childNode.isPropertySignature()) {
                    container.properties.push(_this.factory.getInterfaceProperty(childNode));
                }
                else if (childNode.isConstructSignature()) {
                    container.newSignatures.push(_this.factory.getCallSignatureFromNode(childNode));
                }
                else if (childNode.isCallSignature()) {
                    container.callSignatures.push(_this.factory.getCallSignatureFromNode(childNode));
                }
                else if (childNode.isIndexSignature()) {
                    container.indexSignatures.push(_this.factory.getIndexSignatureFromNode(childNode));
                }
                else if (childNode.isIdentifier()) {
                }
                else if (childNode.isTypeParameter()) {
                }
                else if (childNode.isExportKeyword()) {
                }
                else if (childNode.isDefaultKeyword()) {
                }
                else if (childNode.isHeritageClause()) {
                }
                else {
                    utils_1.Logger.warn("Unknown interface child kind: " + childNode.nodeKindToString());
                }
            });
        });
        Object.keys(methods).forEach(function (name) {
            var methodNode = methods[name];
            utils_1.tryGet(methodNode, function () {
                container.methods.push(_this.factory.getInterfaceMethod(methodNode));
            });
        });
        return container;
    };
    return TsInterfaceBinder;
}(base_1.InterfaceBinder));
exports.TsInterfaceBinder = TsInterfaceBinder;

//# sourceMappingURL=TsInterfaceBinder.js.map
