"use strict";
var path = require("path");
var fs = require("fs");
var main_1 = require("./../main");
function generateStrictStructures() {
    var result = main_1.getInfoFromFiles([path.join(__dirname, "../../src/structures.ts")]);
    var fileDefForCreate = main_1.createFile();
    result.files.filter(function (f) { return f.fileName.indexOf("structures") >= 0; }).forEach(function (f) {
        f.interfaces.forEach(function (i) {
            result.renameDefinitionAs(i, "Strict" + i.name);
            i.properties.forEach(function (p) {
                p.isOptional = false;
            });
            fileDefForCreate.interfaces.push(i);
        });
    });
    fileDefForCreate.addImport({
        defaultImportName: "CodeBlockWriter",
        moduleSpecifier: "code-block-writer"
    });
    fileDefForCreate.onBeforeWrite = function (writer) {
        writer.writeLine("// autogenerated file by gulp generate-strict-structures - DO NOT EDIT!!!").newLine();
    };
    fs.writeFile(path.join(__dirname, "../../src/strictStructures.ts"), fileDefForCreate.write());
}
exports.generateStrictStructures = generateStrictStructures;

//# sourceMappingURL=generateStrictStructures.js.map
