"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var TsSourceFileChild_1 = require("./TsSourceFileChild");
var TsType_1 = require("./TsType");
var TsNode_1 = require("./TsNode");
var TsSymbol_1 = require("./TsSymbol");
var TsSignature = (function (_super) {
    __extends(TsSignature, _super);
    function TsSignature(opts) {
        _super.call(this, opts);
        this.signature = opts.signature;
        this.node = opts.node;
    }
    TsSignature.prototype.getDeclaration = function () {
        return this.createNode(this.signature.declaration);
    };
    TsSignature.prototype.getReturnType = function () {
        var tsType = this.typeChecker.getReturnTypeOfSignature(this.signature);
        return this.getTypeFromType(tsType);
    };
    TsSignature.prototype.getParameters = function () {
        var _this = this;
        var parameters = this.signature.parameters;
        return parameters.filter(function (p) { return p != null; }).map(function (parameter) { return _this.createSymbol(parameter); });
    };
    TsSignature.prototype.getTypeParameters = function () {
        var _this = this;
        var typeParameters = this.signature.typeParameters;
        return (typeParameters || []).map(function (typeParameter) { return _this.createSymbol(typeParameter.symbol); });
    };
    TsSignature.prototype.getTypeFromType = function (tsType) {
        var _this = this;
        return this.tsCache.getType(this.typeChecker, tsType, this.node, function () { return _this.createType(tsType); });
    };
    TsSignature.prototype.createType = function (type) {
        return new TsType_1.TsType({
            sourceFile: this.sourceFile,
            typeChecker: this.typeChecker,
            type: type,
            node: this.node,
            tsCache: this.tsCache,
            tsSourceFile: this.tsSourceFile
        });
    };
    TsSignature.prototype.createNode = function (node) {
        var _this = this;
        return this.tsCache.getNode(node, function () { return new TsNode_1.TsNode({
            sourceFile: _this.sourceFile,
            typeChecker: _this.typeChecker,
            tsCache: _this.tsCache,
            node: node,
            tsSourceFile: _this.tsSourceFile
        }); });
    };
    TsSignature.prototype.createSymbol = function (symbol) {
        return new TsSymbol_1.TsSymbol({
            sourceFile: this.sourceFile,
            tsSourceFile: this.tsSourceFile,
            typeChecker: this.typeChecker,
            tsCache: this.tsCache,
            symbol: symbol
        });
    };
    return TsSignature;
}(TsSourceFileChild_1.TsSourceFileChild));
exports.TsSignature = TsSignature;

//# sourceMappingURL=TsSignature.js.map
