"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var TsBase_1 = require("./TsBase");
var TsNode_1 = require("./TsNode");
var TsSymbol_1 = require("./TsSymbol");
var TsSourceFile = (function (_super) {
    __extends(TsSourceFile, _super);
    function TsSourceFile(opts) {
        _super.call(this, opts);
        this.symbol = opts.symbol;
    }
    TsSourceFile.prototype.getDefaultExportSymbol = function () {
        if (this.fileHasExports()) {
            var defaultExportSymbol = this.symbol.exports["default"];
            if (defaultExportSymbol != null) {
                return this.createSymbol(defaultExportSymbol);
            }
        }
        return null;
    };
    TsSourceFile.prototype.getFileName = function () {
        return this.sourceFile.fileName;
    };
    TsSourceFile.prototype.getNode = function () {
        return this.createNode(this.sourceFile, this.createSymbol(this.symbol));
    };
    TsSourceFile.prototype.fileHasExports = function () {
        return this.symbol != null;
    };
    TsSourceFile.prototype.createNode = function (node, tsSymbol) {
        var _this = this;
        return this.tsCache.getNode(node, function () { return new TsNode_1.TsNode({
            tsCache: _this.tsCache,
            typeChecker: _this.typeChecker,
            node: node,
            tsSourceFile: _this,
            sourceFile: _this.sourceFile
        }, tsSymbol); });
    };
    TsSourceFile.prototype.createSymbol = function (symbol) {
        var _this = this;
        if (symbol == null) {
            return null;
        }
        else {
            return this.tsCache.getSymbol(symbol, function () { return new TsSymbol_1.TsSymbol({
                tsCache: _this.tsCache,
                typeChecker: _this.typeChecker,
                symbol: symbol,
                tsSourceFile: _this,
                sourceFile: _this.sourceFile
            }); });
        }
    };
    return TsSourceFile;
}(TsBase_1.TsBase));
exports.TsSourceFile = TsSourceFile;

//# sourceMappingURL=TsSourceFile.js.map
