"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var ts = require("typescript");
var decorators_1 = require("./../utils/decorators");
var TsSymbol_1 = require("./TsSymbol");
var TsType_1 = require("./TsType");
var TsNode_1 = require("./TsNode");
var TsSourceFileChild_1 = require("./TsSourceFileChild");
var TsTypeNode = (function (_super) {
    __extends(TsTypeNode, _super);
    function TsTypeNode(opts, originalSymbol) {
        _super.call(this, opts);
        this.originalSymbol = originalSymbol;
        if (opts.node == null) {
            throw new Error("Passed in " + "opts" + "." + "node" + " cannot be null.");
        }
        this.node = opts.node;
    }
    Object.defineProperty(TsTypeNode.prototype, "tsSymbol", {
        get: function () {
            return this.originalSymbol || this.createSymbol(this.typeChecker.getSymbolAtLocation(this.node));
        },
        enumerable: true,
        configurable: true
    });
    TsTypeNode.prototype.isIntersectionType = function () {
        return this.node.kind === ts.SyntaxKind.IntersectionType;
    };
    TsTypeNode.prototype.isUnionType = function () {
        return this.node.kind === ts.SyntaxKind.UnionType;
    };
    TsTypeNode.prototype.isArrayTypeNode = function () {
        return this.getArrayElementTypeNode() != null;
    };
    TsTypeNode.prototype.getArrayElementTypeNode = function () {
        var arrayTypeNode = this.node;
        var typeReferenceNode = this.node;
        if (arrayTypeNode.elementType != null) {
            return this.createTypeNode(arrayTypeNode.elementType);
        }
        if (/^Array\<.*\>$/.test(typeReferenceNode.getText()) && typeReferenceNode.typeArguments != null && typeReferenceNode.typeArguments.length === 1) {
            return this.createTypeNode(typeReferenceNode.typeArguments[0]);
        }
        return null;
    };
    TsTypeNode.prototype.getTypeArgumentsTypeNodes = function () {
        var _this = this;
        var typeReferenceNode = this.node;
        var typeArgs = typeReferenceNode.typeArguments || [];
        return typeArgs.map(function (a) { return _this.createTypeNode(a); });
    };
    TsTypeNode.prototype.getTypeParameterNodes = function () {
        var _this = this;
        var typeReferenceNode = this.node;
        var typeArgs = typeReferenceNode.typeParameters || [];
        return typeArgs.map(function (a) { return _this.createNode(a); });
    };
    TsTypeNode.prototype.getText = function () {
        return this.node.getText();
    };
    TsTypeNode.prototype.getType = function () {
        return this.getTypeAtLocationByNode(this.node);
    };
    TsTypeNode.prototype.getMemberNodes = function () {
        var _this = this;
        var typeLiteralNode = this.node;
        var members = typeLiteralNode.members || [];
        return members.map(function (m) { return _this.createNode(m); });
    };
    TsTypeNode.prototype.getParameters = function () {
        var _this = this;
        var typeReferenceNode = this.node;
        var params = typeReferenceNode.parameters || [];
        return params.map(function (p) { return _this.createNode(p); });
    };
    TsTypeNode.prototype.getUnionOrIntersectionTypeNodes = function () {
        var _this = this;
        var unionOrIntersectionTypeNode = this.node;
        var types = unionOrIntersectionTypeNode.types || [];
        return types.map(function (t) { return _this.createTypeNode(t); });
    };
    TsTypeNode.prototype.getTypeAtLocationByNode = function (node) {
        if (node.kind === ts.SyntaxKind.TypeAliasDeclaration) {
            var declaration = node;
            return this.getTypeAtLocationByNode(declaration.type);
        }
        else {
            return this.getTsTypeFromNode(node);
        }
    };
    TsTypeNode.prototype.getTsTypeFromNode = function (node) {
        var _this = this;
        var type = this.typeChecker.getTypeAtLocation(node);
        return this.tsCache.getType(this.typeChecker, type, node, function () { return _this.createType(type, node); });
    };
    TsTypeNode.prototype.createType = function (type, node) {
        return new TsType_1.TsType({
            sourceFile: this.sourceFile,
            typeChecker: this.typeChecker,
            type: type,
            node: node,
            tsCache: this.tsCache,
            tsSourceFile: this.tsSourceFile
        });
    };
    TsTypeNode.prototype.createTypeNode = function (node) {
        var _this = this;
        return this.tsCache.getTypeNode(node, function () { return new TsTypeNode({
            typeChecker: _this.typeChecker,
            sourceFile: _this.sourceFile,
            tsSourceFile: _this.tsSourceFile,
            tsCache: _this.tsCache,
            node: node
        }); });
    };
    TsTypeNode.prototype.createNode = function (node) {
        var _this = this;
        return this.tsCache.getNode(node, function () { return new TsNode_1.TsNode({
            typeChecker: _this.typeChecker,
            sourceFile: _this.sourceFile,
            tsSourceFile: _this.tsSourceFile,
            tsCache: _this.tsCache,
            node: node
        }); });
    };
    TsTypeNode.prototype.createSymbol = function (symbol) {
        var _this = this;
        if (symbol == null) {
            return null;
        }
        else {
            return this.tsCache.getSymbol(symbol, function () { return new TsSymbol_1.TsSymbol({
                typeChecker: _this.typeChecker,
                sourceFile: _this.sourceFile,
                tsSourceFile: _this.tsSourceFile,
                tsCache: _this.tsCache,
                symbol: symbol
            }); });
        }
    };
    __decorate([
        decorators_1.Memoize
    ], TsTypeNode.prototype, "tsSymbol", null);
    return TsTypeNode;
}(TsSourceFileChild_1.TsSourceFileChild));
exports.TsTypeNode = TsTypeNode;

//# sourceMappingURL=TsTypeNode.js.map
