"use strict";
var assert = require("assert");
var main_1 = require("./../../../main");
describe("AmbientableDefinition", function () {
    var code = "\ndeclare namespace MyNamespace {\n}\ndeclare module MyModule {\n}\ndeclare namespace MyOtherNamespace {\n    interface myOtherInterface {}\n    function myOtherFunction(): void;\n}\ndeclare interface MyInterface {\n}\ndeclare class MyClass {\n}\ndeclare enum MyEnum {\n}\ndeclare function myFunction(): void;\n";
    var myFile = main_1.getInfoFromString(code);
    describe("write()", function () {
        it("should contain the file written out with declare keywords", function () {
            var expected = "declare namespace MyNamespace {\n}\n\ndeclare module MyModule {\n}\n\ndeclare namespace MyOtherNamespace {\n    interface myOtherInterface {\n    }\n\n    function myOtherFunction(): void;\n}\n\ndeclare interface MyInterface {\n}\n\ndeclare class MyClass {\n}\n\ndeclare enum MyEnum {\n}\n\ndeclare function myFunction(): void;\n";
            assert.equal(myFile.write(), expected);
        });
    });
});

//# sourceMappingURL=ambientableDefinitionWriteTests.js.map
