"use strict";
var assert = require("assert");
var main_1 = require("./../../../main");
var code = "\nfunction myFunction() {\n}\n";
describe("BaseDefinition", function () {
    var file = main_1.getInfoFromString(code);
    var funcDef = file.functions[0];
    describe("onBeforeWrite", function () {
        it("should write the function with the before text", function () {
            funcDef.onBeforeWrite = function (writer) {
                writer.write("@MyEnumerable");
            };
            funcDef.onAfterWrite = null;
            var expected = "@MyEnumerable\nfunction myFunction() {\n}\n";
            assert.equal(funcDef.write(), expected);
        });
    });
    describe("onAfterWrite", function () {
        it("should write the function with the after text", function () {
            funcDef.onBeforeWrite = null;
            funcDef.onAfterWrite = function (writer) {
                writer.write("// something");
            };
            var expected = "function myFunction() {\n}\n// something\n";
            assert.equal(funcDef.write(), expected);
        });
    });
});

//# sourceMappingURL=baseDefinitionWriteTests.js.map
