"use strict";
var assert = require("assert");
var main_1 = require("./../../../main");
var code = "\nenum MyEnum {\n    enumMember1 = 1,\n    enumMember2\n}\ndeclare const enum MyDeclareConstEnum {\n}\nexport const enum MyExportedConstEnum {\n}\n";
describe("EnumDefinition", function () {
    var file = main_1.getInfoFromString(code);
    describe("#write()", function () {
        it("should contain the enum written out", function () {
            var expected = "enum MyEnum {\n    enumMember1 = 1,\n    enumMember2 = 2\n}\n";
            assert.equal(file.enums[0].write(), expected);
        });
        it("should contain the declared const enum written out", function () {
            var expected = "declare const enum MyDeclareConstEnum {\n}\n";
            assert.equal(file.enums[1].write(), expected);
        });
        it("should contain the exported const enum written out", function () {
            var expected = "export const enum MyExportedConstEnum {\n}\n";
            assert.equal(file.enums[2].write(), expected);
        });
    });
});

//# sourceMappingURL=enumWriteTests.js.map
