"use strict";
var assert = require("assert");
var main_1 = require("./../../../main");
var code = "\nimport myDefaultImport from \"./test\";\nimport * as myStarImport from \"./test\";\nimport {default as myDefaultImport, myFirstNamedImport, mySecondNamedImport} from \"./test\";\nimport myDefaultImport2, {MyActualName as myAlias} from \"./test\";\nimport myDefaultImport3, * as myStarImport2 from \"./test\";\nimport \"./test\";\n\nexport * from \"./test\";\nexport {myExport1, MyActualName as myAlias} from \"./test\";\n\nvar myVariable: string;\nvar mySecondVariable: number;\ntype myType = string;\ntype mySecondType = number;\n\nclass MyClass {\n}\ninterface MyInterface {\n}\nfunction myFunction() {\n}\nenum MyEnum {\n}\nnamespace MyNamespace {\n}\nmodule MyModule {\n}\n\nlet myVarAtEndOfFile = \"\";\n\nexport default MyEnum;\n";
describe("FileDefinition", function () {
    var file = main_1.getInfoFromString(code);
    describe("write()", function () {
        it("should contain the file written out", function () {
            var expected = "import myDefaultImport from \"./test\";\nimport * as myStarImport from \"./test\";\nimport {default as myDefaultImport, myFirstNamedImport, mySecondNamedImport} from \"./test\";\nimport myDefaultImport2, {MyActualName as myAlias} from \"./test\";\nimport myDefaultImport3, * as myStarImport2 from \"./test\";\nimport \"./test\";\n\nexport * from \"./test\";\nexport {myExport1, MyActualName as myAlias} from \"./test\";\n\nvar myVariable: string;\nvar mySecondVariable: number;\n\ntype myType = string;\ntype mySecondType = number;\n\nclass MyClass {\n}\n\ninterface MyInterface {\n}\n\nfunction myFunction() {\n}\n\nenum MyEnum {\n}\n\nnamespace MyNamespace {\n}\n\nmodule MyModule {\n}\n\nlet myVarAtEndOfFile = \"\";\n\nexport default MyEnum;\n";
            assert.equal(file.write(), expected);
        });
    });
});

//# sourceMappingURL=fileWriteTests.js.map
