"use strict";
var assert = require("assert");
var main_1 = require("./../../../main");
var code = "\ntype myTypeAlias = string | number;\ntype myTypeParameteredTypeAlias<T> = T[];\ntype myStringLiteralTypeAlias = \"some string\" | \"other string\";\n";
describe("TypeAliasDefinition", function () {
    var myFile = main_1.getInfoFromString(code);
    describe("#write()", function () {
        describe("myTypeAlias", function () {
            it("should contain everything written out", function () {
                var expected = "type myTypeAlias = string | number;\n";
                assert.equal(myFile.typeAliases[0].write(), expected);
            });
        });
        describe("myTypeParameteredTypeAlias", function () {
            it("should contain everything written out", function () {
                var expected = "type myTypeParameteredTypeAlias<T> = T[];\n";
                assert.equal(myFile.typeAliases[1].write(), expected);
            });
        });
        describe("myStringLiteralTypeAlias", function () {
            it("should contain everything written out", function () {
                var expected = "type myStringLiteralTypeAlias = \"some string\" | \"other string\";\n";
                assert.equal(myFile.typeAliases[2].write(), expected);
            });
        });
    });
});

//# sourceMappingURL=typeAliasWriterTests.js.map
