"use strict";
var assert = require("assert");
var main_1 = require("./../../../main");
var code = "interface SimpleInterface {\n}\n\ninterface MyInterface {\n    myString: string;\n    mySecond: number;\n\n    myMethod(): void;\n    myMethodWithTypeParameter<T>(): void;\n    myMethod2<T>(): string;\n    myMethod2<T>(str?: string): string;\n}\n\ninterface NewSignatureInterface {\n    new<T>(str: string, t: T): string;\n    new(any: any): string;\n}\n\ninterface CallSignatureInterface {\n    <T>(str: string, t: T): string;\n    (num: number): number;\n    (any: any): any;\n}\n\ninterface IndexSignatureInterface {\n    readonly [str: string]: Date;\n    [num: number]: Date;\n}\n\ninterface MyTypeParameterInterface<T> {\n}\n\ninterface MyExtenedInterface extends MyTypeParameterInterface<string> {\n}\n\ninterface MyMultipleExtenedInterface extends MyTypeParameterInterface<string>, MyInterface {\n}\n";
describe("InterfaceDefinition", function () {
    var file = main_1.getInfoFromString(code);
    describe("write()", function () {
        it("should have the same output as the input", function () {
            assert.equal(file.write(), code);
        });
        it("should write when calling it on the interface", function () {
            var expectedCode = "interface SimpleInterface {\n}\n";
            assert.equal(file.interfaces[0].write(), expectedCode);
        });
    });
});

//# sourceMappingURL=interfaceWriteTests.js.map
