"use strict";
var assert = require("assert");
var main_1 = require("./../../../main");
var code = "\nnamespace MyNamespace {\n    type myType = string;\n    type mySecondType = string | number;\n    namespace MyNamespace {\n    }\n    module MyModule {\n    }\n    export interface MyInterface {\n    }\n    class MyClass {\n    }\n    enum MyEnum {\n    }\n    function myFunction() {\n    }\n    let myVar = \"\";\n    let mySecondVar = \"\";\n}\nmodule MyModule {\n    interface MyInterface {\n    }\n}\n";
describe("NamespaceDefinition", function () {
    var myFile = main_1.getInfoFromString(code);
    describe("#write()", function () {
        describe("MyNamespace", function () {
            it("should contain everything written out", function () {
                var expected = "namespace MyNamespace {\n    type myType = string;\n    type mySecondType = string | number;\n\n    namespace MyNamespace {\n    }\n\n    module MyModule {\n    }\n\n    export interface MyInterface {\n    }\n\n    class MyClass {\n    }\n\n    enum MyEnum {\n    }\n\n    function myFunction() {\n    }\n\n    let myVar = \"\";\n    let mySecondVar = \"\";\n}\n";
                assert.equal(myFile.namespaces[0].write(), expected);
            });
        });
        describe("MyModule", function () {
            it("should contain everything written out", function () {
                var expected = "module MyModule {\n    interface MyInterface {\n    }\n}\n";
                assert.equal(myFile.namespaces[1].write(), expected);
            });
        });
    });
});

//# sourceMappingURL=namespaceWriterTests.js.map
