"use strict";
var assert = require("assert");
var main_1 = require("./../../../main");
var code = "\nvar myImplicitAny;\nvar myExplicitTypeVar: number;\nvar myImplicitTypeVar = \"my string\";\nlet myLet: string;\nconst myConst: number;\n";
describe("VariableDefinition", function () {
    var myFile = main_1.getInfoFromString(code);
    describe("write()", function () {
        describe("myImplicitAny", function () {
            it("should contain everything written out", function () {
                var expected = "var myImplicitAny: any;\n";
                assert.equal(myFile.variables[0].write(), expected);
            });
        });
        describe("myExplicitTypeVar", function () {
            it("should contain everything written out", function () {
                var expected = "var myExplicitTypeVar: number;\n";
                assert.equal(myFile.variables[1].write(), expected);
            });
        });
        describe("myImplicitTypeVar", function () {
            it("should write out the expression without the type when a default expression exists", function () {
                var expected = "var myImplicitTypeVar = \"my string\";\n";
                assert.equal(myFile.variables[2].write(), expected);
            });
        });
        describe("myLet", function () {
            it("should contain everything written out", function () {
                var expected = "let myLet: string;\n";
                assert.equal(myFile.variables[3].write(), expected);
            });
        });
        describe("myConst", function () {
            it("should contain everything written out", function () {
                var expected = "const myConst: number;\n";
                assert.equal(myFile.variables[4].write(), expected);
            });
        });
    });
});

//# sourceMappingURL=variableWriterTests.js.map
