"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("class abstract tests", function () {
    var code = "\nabstract class MyAbstractClass {\n    abstract myAbstractMethod(): string;\n    abstract myAbstractMethod(str?: string): string;\n}";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        classes: [{
                name: "MyAbstractClass",
                isAbstract: true,
                methods: [{
                        name: "myAbstractMethod",
                        isAbstract: true,
                        returnType: { text: "string" },
                        parameters: [{
                                name: "str",
                                type: { text: "string" },
                                isOptional: true
                            }],
                        overloadSignatures: [{
                                returnType: { text: "string" }
                            }]
                    }]
            }]
    });
});

//# sourceMappingURL=abstractTests.js.map
