"use strict";
var main_1 = require("./../../../main");
var definitions_1 = require("./../../../definitions");
var testHelpers_1 = require("./../../testHelpers");
describe("class constructor tests", function () {
    var code = "\nclass MyClass1 {\n}\nclass MyClass2 {\n    constructor() {\n    }\n}\nclass MyClass3 {\n    constructor(parameter1: string) {\n    }\n}\nclass MyClass4 {\n    constructor(readonly param1: string, public param2: string, protected readonly param3: number, private param4 = new Date()) {\n    }\n}\nclass MyClass5 {\n    private constructor() {\n    }\n}\nclass MyClass6 {\n    protected constructor() {\n    }\n}\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        classes: [{
                name: "MyClass1"
            }, {
                name: "MyClass2",
                constructorDef: {}
            }, {
                name: "MyClass3",
                constructorDef: {
                    parameters: [{
                            name: "parameter1",
                            type: { text: "string" }
                        }]
                }
            }, {
                name: "MyClass4",
                constructorDef: {
                    parameters: [{
                            name: "param1",
                            type: { text: "string" },
                            scope: definitions_1.ClassConstructorParameterScope.Public,
                            isReadonly: true
                        }, {
                            name: "param2",
                            type: { text: "string" },
                            scope: definitions_1.ClassConstructorParameterScope.Public
                        }, {
                            name: "param3",
                            type: { text: "number" },
                            scope: definitions_1.ClassConstructorParameterScope.Protected,
                            isReadonly: true
                        }, {
                            name: "param4",
                            type: { text: "Date" },
                            defaultExpression: { text: "new Date()" },
                            scope: definitions_1.ClassConstructorParameterScope.Private,
                            isOptional: true
                        }]
                }
            }, {
                name: "MyClass5",
                constructorDef: {
                    scope: definitions_1.Scope.Private
                }
            }, {
                name: "MyClass6",
                constructorDef: {
                    scope: definitions_1.Scope.Protected
                }
            }]
    });
});

//# sourceMappingURL=constructorTests.js.map
