"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("class decorator tests", function () {
    var code = "\nfunction MyClassDecorator(target: Function) {\n}\n\n@MyClassDecorator\nclass MyClass1 {\n}\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        functions: [{
                name: "MyClassDecorator",
                parameters: [{
                        name: "target",
                        type: {
                            text: "Function"
                        }
                    }]
            }],
        classes: [{
                name: "MyClass1",
                decorators: [{
                        name: "MyClassDecorator"
                    }]
            }]
    });
});

//# sourceMappingURL=decoratorTests.js.map
