"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("class extends implements tests", function () {
    var code = "\ninterface MyInterface {\n    name: string;\n}\n\nclass MyBaseClass {\n    prop: string;\n}\n\nclass MyExtendsImplementsClass extends MyBaseClass implements MyInterface {\n    name: string;\n}\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        interfaces: [{
                name: "MyInterface",
                properties: [{
                        name: "name",
                        type: {
                            text: "string"
                        }
                    }]
            }],
        classes: [{
                name: "MyBaseClass",
                properties: [{
                        name: "prop",
                        type: {
                            text: "string"
                        }
                    }]
            }, {
                name: "MyExtendsImplementsClass",
                extendsTypes: [{ text: "MyBaseClass" }],
                implementsTypes: [{ text: "MyInterface" }],
                properties: [{
                        name: "name",
                        type: {
                            text: "string"
                        }
                    }]
            }]
    });
});

//# sourceMappingURL=extendsImplementsTests.js.map
