"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("class implements class tests", function () {
    var code = "\nclass MyBaseClass {\n    name1: string;\n}\n\nclass MyClassImplementsClass implements MyBaseClass {\n    name1: string;\n    name2: string;\n}\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        classes: [{
                name: "MyBaseClass",
                properties: [{
                        name: "name1",
                        type: {
                            text: "string"
                        }
                    }]
            }, {
                name: "MyClassImplementsClass",
                implementsTypes: [{ text: "MyBaseClass" }],
                properties: [{
                        name: "name1",
                        type: {
                            text: "string"
                        }
                    }, {
                        name: "name2",
                        type: {
                            text: "string"
                        }
                    }]
            }]
    });
});

//# sourceMappingURL=implementsClassTests.js.map
