"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("class implements interface tests", function () {
    var code = "\ninterface MyInterface {\n    name: string;\n}\n\ninterface MyTest {\n    name2: string;\n}\n\nclass MyClassImplementsInterface implements MyInterface, MyTest {\n    name: string;\n    name2: string;\n}\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        interfaces: [{
                name: "MyInterface",
                properties: [{
                        name: "name",
                        type: {
                            text: "string"
                        }
                    }]
            }, {
                name: "MyTest",
                properties: [{
                        name: "name2",
                        type: {
                            text: "string"
                        }
                    }]
            }],
        classes: [{
                name: "MyClassImplementsInterface",
                implementsTypes: [{ text: "MyInterface" }, { text: "MyTest" }],
                properties: [{
                        name: "name",
                        type: {
                            text: "string"
                        }
                    }, {
                        name: "name2",
                        type: {
                            text: "string"
                        }
                    }]
            }]
    });
});

//# sourceMappingURL=implementsInterfaceTests.js.map
