"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("class method decorator tests", function () {
    var code = "\nfunction MyClassMethodDecorator(target: Object, propertyKey: string, descriptor: TypedPropertyDescriptor<any>) {\n    return descriptor;\n}\n\nclass MyClass {\n    @MyClassMethodDecorator\n    myMethod() {\n    }\n}\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        functions: [{
                name: "MyClassMethodDecorator",
                parameters: [{
                        name: "target",
                        type: {
                            text: "Object"
                        }
                    }, {
                        name: "propertyKey",
                        type: {
                            text: "string"
                        }
                    }, {
                        name: "descriptor",
                        type: {
                            text: "TypedPropertyDescriptor<any>"
                        }
                    }],
                returnType: {
                    text: "TypedPropertyDescriptor<any>"
                }
            }],
        classes: [{
                name: "MyClass",
                methods: [{
                        name: "myMethod",
                        decorators: [{
                                name: "MyClassMethodDecorator"
                            }]
                    }]
            }]
    });
});

//# sourceMappingURL=methodDecoratorTests.js.map
