"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("class method decorator parameter tests", function () {
    var code = "\nfunction MyClassMethodParameterDecorator(target: any, propertyKey: string, parameterIndex: number) {\n}\n\nclass MyClass {\n    myMethod1(@MyClassMethodParameterDecorator param1: string) {\n    }\n}\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        functions: [{
                name: "MyClassMethodParameterDecorator",
                parameters: [{
                        name: "target",
                        type: {
                            text: "any"
                        }
                    }, {
                        name: "propertyKey",
                        type: {
                            text: "string"
                        }
                    }, {
                        name: "parameterIndex",
                        type: {
                            text: "number"
                        }
                    }]
            }],
        classes: [{
                name: "MyClass",
                methods: [{
                        name: "myMethod1",
                        parameters: [{
                                name: "param1",
                                type: {
                                    text: "string"
                                },
                                decorators: [{
                                        name: "MyClassMethodParameterDecorator"
                                    }]
                            }]
                    }]
            }]
    });
});

//# sourceMappingURL=methodParameterDecoratorTests.js.map
