"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("class static method decorator tests", function () {
    var code = "\nfunction MyClassStaticMethodDecorator(target: Object, propertyKey: string, descriptor: TypedPropertyDescriptor<any>) {\n    return descriptor;\n}\n\nclass MyClass {\n    @MyClassStaticMethodDecorator\n    static myStaticMethod() {\n    }\n}\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        functions: [{
                name: "MyClassStaticMethodDecorator",
                parameters: [{
                        name: "target",
                        type: {
                            text: "Object"
                        }
                    }, {
                        name: "propertyKey",
                        type: {
                            text: "string"
                        }
                    }, {
                        name: "descriptor",
                        type: {
                            text: "TypedPropertyDescriptor<any>"
                        }
                    }],
                returnType: {
                    text: "TypedPropertyDescriptor<any>"
                }
            }],
        classes: [{
                name: "MyClass",
                staticMethods: [{
                        name: "myStaticMethod",
                        decorators: [{
                                name: "MyClassStaticMethodDecorator"
                            }]
                    }]
            }]
    });
});

//# sourceMappingURL=staticMethodDecoratorTests.js.map
