"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("class method overload signature tests", function () {
    var code = "\nclass MyClass {\n    static myMethod<T>(num: number, t: T): number;\n    static myMethod<T>(str: string, t: T): string;\n    static myMethod<T>(myStringOrNumber: string | number, t: T): string {\n    }\n}\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        classes: [{
                name: "MyClass",
                staticMethods: [{
                        name: "myMethod",
                        overloadSignatures: [{
                                parameters: [{
                                        name: "num",
                                        type: { text: "number" }
                                    }, {
                                        name: "t",
                                        type: { text: "T" }
                                    }],
                                typeParameters: [{
                                        name: "T"
                                    }],
                                returnType: { text: "number" },
                                minArgumentCount: 2
                            }, {
                                parameters: [{
                                        name: "str",
                                        type: { text: "string" }
                                    }, {
                                        name: "t",
                                        type: { text: "T" }
                                    }],
                                typeParameters: [{
                                        name: "T"
                                    }],
                                returnType: { text: "string" },
                                minArgumentCount: 2
                            }],
                        parameters: [{
                                name: "myStringOrNumber",
                                type: {
                                    text: "string | number",
                                    unionTypes: [{
                                            text: "string"
                                        }, {
                                            text: "number"
                                        }]
                                }
                            }, {
                                name: "t",
                                type: { text: "T" }
                            }],
                        typeParameters: [{
                                name: "T"
                            }],
                        returnType: { text: "string" }
                    }]
            }]
    });
});

//# sourceMappingURL=staticMethodOverloadSignatureTests.js.map
