"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("class static property decorator tests", function () {
    var code = "\nfunction MyClassStaticPropertyDecorator(target: Object, propertyKey: string) {\n}\n\nclass MyClass {\n    @MyClassStaticPropertyDecorator\n    static myStaticProperty: string;\n}\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        functions: [{
                name: "MyClassStaticPropertyDecorator",
                parameters: [{
                        name: "target",
                        type: {
                            text: "Object"
                        }
                    }, {
                        name: "propertyKey",
                        type: {
                            text: "string"
                        }
                    }]
            }],
        classes: [{
                name: "MyClass",
                staticProperties: [{
                        name: "myStaticProperty",
                        type: {
                            text: "string"
                        },
                        decorators: [{
                                name: "MyClassStaticPropertyDecorator"
                            }]
                    }]
            }]
    });
});

//# sourceMappingURL=staticPropertyDecoratorTests.js.map
