"use strict";
var main_1 = require("./../../../main");
var definitions_1 = require("./../../../definitions");
var testHelpers_1 = require("./../../testHelpers");
describe("class static property tests", function () {
    var code = "\nclass MyClass {\n    static readonly myString: string;\n    static myImplicit = 4;\n    static myAny;\n    static myOptional?: string;\n\n    public static myExplicitPublic;\n    protected static myProtected;\n    private static myPrivate;\n}";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        classes: [{
                name: "MyClass",
                staticProperties: [{
                        name: "myString",
                        isReadonly: true,
                        type: { text: "string" }
                    }, {
                        name: "myImplicit",
                        type: { text: "number" },
                        defaultExpression: { text: "4" }
                    }, {
                        name: "myAny",
                        type: { text: "any" }
                    }, {
                        name: "myOptional",
                        type: { text: "string" },
                        isOptional: true
                    }, {
                        name: "myExplicitPublic",
                        type: { text: "any" },
                        scope: definitions_1.Scope.Public
                    }, {
                        name: "myProtected",
                        type: { text: "any" },
                        scope: definitions_1.Scope.Protected
                    }, {
                        name: "myPrivate",
                        type: { text: "any" },
                        scope: definitions_1.Scope.Private
                    }]
            }]
    });
});

//# sourceMappingURL=staticPropertyTests.js.map
