"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("class type parameters", function () {
    var code = "\nclass MyClass<T, U extends string> {\n    tProp: T;\n    uProp: U;\n}\n\nclass MyExtendsClass extends MyClass<number, string> {\n}\n\nclass MyImplementsClass implements MyClass<number, string> {\n    tProp: number;\n    uProp: string;\n}\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        classes: [{
                name: "MyClass",
                typeParameters: [{
                        name: "T"
                    }, {
                        name: "U",
                        constraintType: { text: "string" }
                    }],
                properties: [{
                        name: "tProp",
                        type: { text: "T" }
                    }, {
                        name: "uProp",
                        type: { text: "U" }
                    }]
            }, {
                name: "MyExtendsClass",
                extendsTypes: [{
                        text: "MyClass<number, string>"
                    }]
            }, {
                name: "MyImplementsClass",
                implementsTypes: [{
                        text: "MyClass<number, string>"
                    }],
                properties: [{
                        name: "tProp",
                        type: { text: "number" }
                    }, {
                        name: "uProp",
                        type: { text: "string" }
                    }]
            }]
    });
});

//# sourceMappingURL=typeParameterTests.js.map
