"use strict";
var main_1 = require("./../../../main");
var definitions_1 = require("./../../../definitions");
var testHelpers_1 = require("./../../testHelpers");
describe("declaration merging module with class", function () {
    var code = "\nmodule MyModuleWithClass {\n    export function myFunction() {}\n}\n\nclass MyModuleWithClass {\n    myMethod() {}\n}\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        namespaces: [{
                name: "MyModuleWithClass",
                declarationType: definitions_1.NamespaceDeclarationType.Module,
                functions: [{
                        name: "myFunction",
                        isExported: true
                    }],
                exports: [{
                        name: "myFunction"
                    }]
            }],
        classes: [{
                name: "MyModuleWithClass",
                methods: [{
                        name: "myMethod"
                    }]
            }]
    });
});

//# sourceMappingURL=moduleWithClass.js.map
