"use strict";
var main_1 = require("./../../../main");
var definitions_1 = require("./../../../definitions");
var testHelpers_1 = require("./../../testHelpers");
describe("declaration merging variable with type alias", function () {
    var code = "\ntype VariableDeclarationType = \"var\" | \"let\" | \"const\";\n\nconst VariableDeclarationType = {\n    Var: \"var\" as VariableDeclarationType,\n    Let: \"let\" as VariableDeclarationType,\n    Const: \"const\" as VariableDeclarationType\n};\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        variables: [{
                name: "VariableDeclarationType",
                declarationType: definitions_1.VariableDeclarationType.Const,
                type: {
                    text: "{ Var: VariableDeclarationType; Let: VariableDeclarationType; Const: VariableDeclarationType; }"
                },
                defaultExpression: {
                    text: "{\n    Var: \"var\" as VariableDeclarationType,\n    Let: \"let\" as VariableDeclarationType,\n    Const: \"const\" as VariableDeclarationType\n}"
                }
            }],
        typeAliases: [{
                name: "VariableDeclarationType",
                type: {
                    text: "\"var\" | \"let\" | \"const\"",
                    unionTypes: [{
                            text: "\"var\""
                        }, {
                            text: "\"let\""
                        }, {
                            text: "\"const\""
                        }]
                }
            }]
    });
});

//# sourceMappingURL=variableWithTypeAlias.js.map
