"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("enum tests", function () {
    var code = "\nenum MyEnum {\n    MyImplicit,\n    MyExplicit = 7\n}\n\nexport enum MyExportedEnum {\n}\n\nconst enum MyConstEnum {\n}";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        enums: [{
                name: "MyEnum",
                members: [{
                        name: "MyImplicit",
                        value: 0
                    }, {
                        name: "MyExplicit",
                        value: 7
                    }]
            }, {
                name: "MyExportedEnum",
                isExported: true,
                isNamedExportOfFile: true
            }, {
                name: "MyConstEnum",
                isConst: true
            }],
        exports: [{
                name: "MyExportedEnum"
            }]
    });
});

//# sourceMappingURL=enumTests.js.map
