"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("array type tests", function () {
    var code = "\nlet t: Array<MyClass>;\nlet u: string[];\nlet v: string[][];\nlet w: Array<Array<string>>;\nclass MyClass {\n}\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        variables: [{
                name: "t",
                type: {
                    text: "MyClass[]",
                    isArrayType: true,
                    arrayElementType: {
                        text: "MyClass",
                        definitions: [{
                                name: "MyClass"
                            }],
                        allDefinitions: [{
                                name: "MyClass"
                            }]
                    },
                    definitions: [],
                    allDefinitions: [{
                            name: "MyClass"
                        }],
                    node: {
                        text: "Array<MyClass>",
                        isArrayType: true,
                        arrayElementType: {
                            text: "MyClass",
                            definitions: [{
                                    name: "MyClass"
                                }],
                            allDefinitions: [{
                                    name: "MyClass"
                                }]
                        },
                        definitions: [],
                        allDefinitions: [{
                                name: "MyClass"
                            }]
                    }
                }
            }, {
                name: "u",
                type: {
                    text: "string[]",
                    isArrayType: true,
                    arrayElementType: {
                        text: "string"
                    }
                }
            }, {
                name: "v",
                type: {
                    text: "string[][]",
                    isArrayType: true,
                    arrayElementType: {
                        text: "string[]",
                        isArrayType: true,
                        arrayElementType: {
                            text: "string"
                        }
                    }
                }
            }, {
                name: "w",
                type: {
                    text: "string[][]",
                    isArrayType: true,
                    arrayElementType: {
                        text: "string[]",
                        isArrayType: true,
                        arrayElementType: {
                            text: "string"
                        }
                    },
                    node: {
                        text: "Array<Array<string>>",
                        isArrayType: true,
                        arrayElementType: {
                            text: "string[]",
                            isArrayType: true,
                            arrayElementType: {
                                text: "string"
                            },
                            node: {
                                text: "Array<string>",
                                isArrayType: true,
                                arrayElementType: {
                                    text: "string"
                                }
                            }
                        }
                    }
                }
            }],
        classes: [{
                name: "MyClass"
            }]
    });
});

//# sourceMappingURL=arrayTypeTests.js.map
