"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("function type tests", function () {
    var code = "\nfunction myFunc(func: <T extends string>(str: T, num?: number) => void) {\n}";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        functions: [{
                name: "myFunc",
                parameters: [{
                        name: "func",
                        type: {
                            text: "<T extends string>(str: T, num?: number) => void",
                            callSignatures: [{
                                    minArgumentCount: 1,
                                    typeParameters: [{
                                            name: "T",
                                            constraintType: { text: "string" }
                                        }],
                                    parameters: [{
                                            name: "str",
                                            type: { text: "T" }
                                        }, {
                                            name: "num",
                                            type: { text: "number" },
                                            isOptional: true
                                        }]
                                }],
                            node: {
                                text: "<T extends string>(str: T, num?: number) => void",
                                parameters: [{
                                        name: "str",
                                        type: { text: "T" }
                                    }, {
                                        name: "num",
                                        type: { text: "number" },
                                        isOptional: true
                                    }],
                                typeParameters: [{
                                        name: "T",
                                        constraintType: { text: "string" }
                                    }]
                            }
                        }
                    }]
            }]
    });
});

//# sourceMappingURL=functionTypeTests.js.map
