"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("generic type tests", function () {
    var code = "\ntype MyType<T> = { prop: T; };\nlet t: MyType<string>;\nlet u: MyType<MyType<string>>;\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        typeAliases: [{
                name: "MyType",
                typeParameters: [{
                        name: "T"
                    }],
                type: {
                    text: "{ prop: T; }"
                }
            }],
        variables: [{
                name: "t",
                type: {
                    text: "MyType<string>",
                    typeArguments: [{
                            text: "string"
                        }]
                }
            }, {
                name: "u",
                type: {
                    text: "MyType<MyType<string>>",
                    typeArguments: [{
                            text: "MyType<string>",
                            typeArguments: [{
                                    text: "string"
                                }]
                        }],
                    node: {
                        text: "MyType<MyType<string>>",
                        typeArguments: [{
                                text: "MyType<string>",
                                typeArguments: [{
                                        text: "string"
                                    }]
                            }]
                    }
                }
            }]
    });
});

//# sourceMappingURL=genericTypeTests.js.map
