"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("object type tests", function () {
    var code = "\nlet obj: { myString: string; myOtherType?: Note; myNext: string; myNext2: string; myReallyReallyReallyReallyReallyLongName: string; };\n\nclass Note {\n    prop: string;\n}";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        variables: [{
                name: "obj",
                type: {
                    text: "{ myString: string; myOtherType?: Note; myNext: string; myNext2: string; myReallyReallyReallyReallyReallyLongName: string; }",
                    properties: [{
                            name: "myString",
                            type: { text: "string" }
                        }, {
                            name: "myOtherType",
                            isOptional: true,
                            type: {
                                text: "Note",
                                properties: [] // shouldn't have any properties
                            }
                        }, {
                            name: "myNext",
                            type: { text: "string" }
                        }, {
                            name: "myNext2",
                            type: { text: "string" }
                        }, {
                            name: "myReallyReallyReallyReallyReallyLongName",
                            type: { text: "string" }
                        }]
                }
            }],
        classes: [{
                name: "Note",
                properties: [{
                        name: "prop",
                        type: { text: "string" }
                    }]
            }]
    });
});

//# sourceMappingURL=objectTypeTests.js.map
