"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("recursive type tests", function () {
    var code = "\nclass Note {\n    name: string;\n    note: Note;\n\n    myMethod(note: Note) {\n        let notes: Note[];\n        return notes;\n    }\n}\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        classes: [{
                name: "Note",
                properties: [{
                        name: "name",
                        type: { text: "string" }
                    }, {
                        name: "note",
                        type: { text: "Note" }
                    }],
                methods: [{
                        name: "myMethod",
                        parameters: [{
                                name: "note",
                                type: { text: "Note" }
                            }],
                        returnType: {
                            text: "Note[]",
                            isArrayType: true,
                            arrayElementType: { text: "Note" }
                        }
                    }]
            }]
    });
});

//# sourceMappingURL=recursiveTypeTests.js.map
