"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("type alias type tests", function () {
    var code = "\ntype MyTypeAlias = { prop: string; };\ntype MyUnionTypeAlias = { prop: string; } | string;\nlet a: MyTypeAlias;\nlet b: MyUnionTypeAlias;\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        typeAliases: [{
                name: "MyTypeAlias",
                type: {
                    text: "{ prop: string; }"
                }
            }, {
                name: "MyUnionTypeAlias",
                type: {
                    text: "string | { prop: string; }",
                    unionTypes: [{
                            text: "string"
                        }, {
                            text: "{ prop: string; }"
                        }]
                }
            }],
        variables: [{
                name: "a",
                type: {
                    text: "MyTypeAlias",
                    definitions: [{
                            name: "MyTypeAlias"
                        }],
                    allDefinitions: [{
                            name: "MyTypeAlias"
                        }]
                }
            }, {
                name: "b",
                type: {
                    text: "MyUnionTypeAlias",
                    definitions: [{
                            name: "MyUnionTypeAlias"
                        }],
                    allDefinitions: [{
                            name: "MyUnionTypeAlias"
                        }]
                }
            }]
    });
});

//# sourceMappingURL=typeAliasTypeTests.js.map
