"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("union type tests", function () {
    var code = "\nclass MyClass {\n    prop: MyClass | MyOtherClass<MyClass>;\n}\n\nclass MyOtherClass<T> {\n    recursiveRelationshipProp: MyClass;\n}\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        classes: [{
                name: "MyClass",
                properties: [{
                        name: "prop",
                        type: {
                            text: "MyClass | MyOtherClass<MyClass>",
                            unionTypes: [{
                                    text: "MyClass",
                                    definitions: [{
                                            name: "MyClass"
                                        }],
                                    allDefinitions: [{
                                            name: "MyClass"
                                        }]
                                }, {
                                    text: "MyOtherClass<MyClass>",
                                    typeArguments: [{
                                            text: "MyClass",
                                            definitions: [{
                                                    name: "MyClass"
                                                }]
                                        }],
                                    definitions: [{
                                            name: "MyOtherClass"
                                        }],
                                    allDefinitions: [{
                                            name: "MyOtherClass"
                                        }]
                                }],
                            definitions: [],
                            allDefinitions: [{
                                    name: "MyClass"
                                }, {
                                    name: "MyOtherClass"
                                }]
                        }
                    }]
            }, {
                name: "MyOtherClass",
                typeParameters: [{
                        name: "T"
                    }],
                properties: [{
                        name: "recursiveRelationshipProp",
                        type: {
                            text: "MyClass",
                            definitions: [{
                                    name: "MyClass"
                                }],
                            allDefinitions: [{
                                    name: "MyClass"
                                }]
                        }
                    }]
            }]
    });
});

//# sourceMappingURL=unionTypeTests.js.map
