"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("export default tests", function () {
    describe("expression", function () {
        var code = "export default 23;";
        var def = main_1.getInfoFromString(code);
        testHelpers_1.runFileDefinitionTests(def, {
            defaultExportExpression: { text: "23" }
        });
    });
    describe("on same line", function () {
        var code = "export default class MyOnSameLineClass {}";
        var def = main_1.getInfoFromString(code);
        testHelpers_1.runFileDefinitionTests(def, {
            classes: [{
                    name: "MyOnSameLineClass",
                    isExported: true,
                    isDefaultExportOfFile: true
                }]
        });
    });
    describe("on different line", function () {
        var code = "class MyOnDifferentLineClass {}\r\nexport default MyOnDifferentLineClass;";
        var def = main_1.getInfoFromString(code);
        testHelpers_1.runFileDefinitionTests(def, {
            defaultExportExpression: { text: "MyOnDifferentLineClass" },
            classes: [{
                    name: "MyOnDifferentLineClass",
                    isExported: true,
                    isDefaultExportOfFile: true
                }]
        });
    });
    describe("expression with class", function () {
        var code = "class MyOnDifferentLineClass {}\r\nexport default new MyOnDifferentLineClass();";
        var def = main_1.getInfoFromString(code);
        testHelpers_1.runFileDefinitionTests(def, {
            defaultExportExpression: { text: "new MyOnDifferentLineClass()" },
            classes: [{
                    name: "MyOnDifferentLineClass"
                }]
        });
    });
});

//# sourceMappingURL=exportDefaultTests.js.map
