"use strict";
var path = require("path");
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
var definitions_1 = require("./../../../definitions");
// See Issue #23
describe("multiple file definition tests", function () {
    var fileName = path.join(__dirname, "../../../../src/tests/languageTests/file/testFiles/reference/main.ts");
    var result = main_1.getInfoFromFiles([fileName]);
    var mainFileDef = result.getFile("main.ts");
    var referenceFileDef = result.getFile("referenceStructures.d.ts");
    testHelpers_1.runFileDefinitionTests(mainFileDef, {
        variables: [{
                declarationType: definitions_1.VariableDeclarationType.Var,
                name: "c",
                type: { text: "MyReferenceClass" }
            }, {
                declarationType: definitions_1.VariableDeclarationType.Var,
                name: "i",
                type: { text: "MyReferenceInterface" }
            }, {
                declarationType: definitions_1.VariableDeclarationType.Var,
                name: "f",
                type: { text: "typeof MyReferenceFunction" },
                defaultExpression: { text: "MyReferenceFunction" }
            }, {
                declarationType: definitions_1.VariableDeclarationType.Var,
                name: "e",
                type: { text: "MyReferenceEnum" }
            }, {
                declarationType: definitions_1.VariableDeclarationType.Var,
                name: "t",
                type: { text: "MyReferenceType" }
            }]
    });
    testHelpers_1.runFileDefinitionTests(referenceFileDef, {
        classes: [{
                name: "MyReferenceClass",
                isAmbient: true,
                hasDeclareKeyword: true
            }],
        interfaces: [{
                name: "MyReferenceInterface",
                isAmbient: true,
                hasDeclareKeyword: true
            }],
        enums: [{
                name: "MyReferenceEnum",
                isAmbient: true,
                hasDeclareKeyword: true
            }],
        functions: [{
                name: "MyReferenceFunction",
                isAmbient: true,
                hasDeclareKeyword: true
            }],
        typeAliases: [{
                name: "MyReferenceType",
                isAmbient: true,
                hasDeclareKeyword: true,
                type: {
                    text: "{ prop: string; }"
                }
            }]
    });
});

//# sourceMappingURL=multipleFileDefinitionTests.js.map
