"use strict";
var path = require("path");
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
var definitions_1 = require("./../../../definitions");
describe("file re-export tests", function () {
    var fileName = path.join(__dirname, "../../../../src/tests/languageTests/file/reExportTestFiles/reExport.ts");
    var fileDef = main_1.getInfoFromFiles([fileName]).getFile("reExport.ts");
    testHelpers_1.runFileDefinitionTests(fileDef, {
        reExports: [{
                moduleSpecifier: "./namedDefaultExports",
                fileName: "namedDefaultExports.ts",
                namedExports: [{
                        name: "NamedExport1",
                        definitions: [{
                                name: "NamedExport1",
                                type: definitions_1.ClassDefinition
                            }, {
                                name: "NamedExport1",
                                type: definitions_1.NamespaceDefinition
                            }]
                    }]
            }, {
                moduleSpecifier: "./namedDefaultExports",
                fileName: "namedDefaultExports.ts",
                namedExports: [{
                        name: "default",
                        alias: "DefaultExportClass",
                        definitions: [{
                                name: "DefaultExport",
                                type: definitions_1.ClassDefinition
                            }]
                    }]
            }, {
                moduleSpecifier: "./exportStar",
                fileName: "exportStar.ts",
                starExports: [{
                        name: "NamedExportEnum",
                        definitions: [{
                                name: "NamedExportEnum",
                                type: definitions_1.EnumDefinition
                            }]
                    }, {
                        name: "NamedExportEnum2",
                        definitions: [{
                                name: "NamedExportEnum2",
                                type: definitions_1.EnumDefinition
                            }]
                    }]
            }, {
                moduleSpecifier: "./exportStar2",
                fileName: "exportStar2.ts",
                starExports: [{
                        name: "ExportStar2Class",
                        definitions: [{
                                name: "ExportStar2Class",
                                type: definitions_1.ClassDefinition
                            }]
                    }]
            }, {
                moduleSpecifier: "./expression",
                fileName: "expression.ts",
                namedExports: [{
                        name: "default",
                        alias: "Expression",
                        expression: {
                            text: "5"
                        }
                    }]
            }, {
                moduleSpecifier: "./reExportCombined",
                fileName: "reExportCombined.ts",
                starExports: [{
                        name: "RenamedA1",
                        definitions: [{
                                name: "SingleNamedExportA",
                                type: definitions_1.ClassDefinition
                            }]
                    }, {
                        name: "RenamedA2",
                        definitions: [{
                                name: "SingleNamedExportA",
                                type: definitions_1.ClassDefinition
                            }]
                    }, {
                        name: "RenamedA3",
                        definitions: [{
                                name: "SingleNamedExportA",
                                type: definitions_1.ClassDefinition
                            }]
                    }, {
                        name: "SingleNamedExportB",
                        definitions: [{
                                name: "SingleNamedExportB",
                                type: definitions_1.ClassDefinition
                            }]
                    }, {
                        name: "NamedExpression",
                        expression: { text: "5" }
                    }]
            }],
        exports: [{
                name: "NamedExport1"
            }, {
                name: "NamedExport1"
            }, {
                name: "DefaultExport",
                isNamedExportOfFile: false,
                isDefaultExportOfFile: true
            }, {
                name: "NamedExportEnum"
            }, {
                name: "NamedExportEnum2"
            }, {
                name: "ExportStar2Class"
            }, {
                name: "SingleNamedExportA"
            }, {
                name: "SingleNamedExportB"
            }]
    });
});

//# sourceMappingURL=reExportTests.js.map
