"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("function type parameters", function () {
    var code = "\nfunction myTypeParameterFunction<T, U extends string>(tParam: T, uParam: U) {\n}";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        functions: [{
                name: "myTypeParameterFunction",
                typeParameters: [{
                        name: "T"
                    }, {
                        name: "U",
                        constraintType: { text: "string" }
                    }],
                parameters: [{
                        name: "tParam",
                        type: { text: "T" }
                    }, {
                        name: "uParam",
                        type: { text: "U" }
                    }]
            }]
    });
});

//# sourceMappingURL=typeParameterTests.js.map
