"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("decorator arguments tests", function () {
    var code = "\nfunction MyClassDecorator(myArg: string) {\n    return (target: Function) => {\n    };\n}\n\n@MyClassDecorator(\"My Value\")\nclass MyClass1 {\n}\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        functions: [{
                name: "MyClassDecorator",
                parameters: [{
                        name: "myArg",
                        type: {
                            text: "string"
                        }
                    }],
                returnType: {
                    text: "(target: Function) => void"
                }
            }],
        classes: [{
                name: "MyClass1",
                decorators: [{
                        name: "MyClassDecorator",
                        arguments: [{
                                text: "\"My Value\""
                            }]
                    }]
            }]
    });
});

//# sourceMappingURL=decoratorArgumentsTests.js.map
