"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("type alias tests", function () {
    var code = "\ntype myStringTypeAlias = string;\ntype myUnionTypeAlias = string | number;\ntype myTypeAliasWithTypeParameter<T> = T;\ntype myTypeAliasWithTypeParameterConstraint<T extends string> = T;\nexport type myExportedType = string;\ntype myStringLiteralTypeAlias = \"some string\" | \"other string\";\nlet myVariableUsingType: myUnionTypeAlias;\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        variables: [{
                name: "myVariableUsingType",
                type: {
                    text: "myUnionTypeAlias"
                }
            }],
        typeAliases: [{
                name: "myStringTypeAlias",
                type: { text: "string" }
            }, {
                name: "myUnionTypeAlias",
                type: {
                    text: "string | number",
                    unionTypes: [{
                            text: "string"
                        }, {
                            text: "number"
                        }]
                }
            }, {
                name: "myTypeAliasWithTypeParameter",
                typeParameters: [{
                        name: "T"
                    }],
                type: { text: "T" }
            }, {
                name: "myTypeAliasWithTypeParameterConstraint",
                typeParameters: [{
                        name: "T",
                        constraintType: { text: "string" }
                    }],
                type: { text: "T" }
            }, {
                name: "myExportedType",
                type: { text: "string" },
                isExported: true,
                isNamedExportOfFile: true
            }, {
                name: "myStringLiteralTypeAlias",
                type: {
                    text: "\"some string\" | \"other string\"",
                    unionTypes: [{
                            text: "\"some string\""
                        }, {
                            text: "\"other string\""
                        }]
                }
            }],
        exports: [{
                name: "myExportedType"
            }]
    });
});

//# sourceMappingURL=typeAliasTests.js.map
