"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("call signature tests", function () {
    var code = "\ninterface MyInterface {\n    (myParameter: string): string;\n    (myParameter: number): number;\n    (myParameter: any): any;\n}";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        interfaces: [{
                name: "MyInterface",
                callSignatures: [{
                        returnType: { text: "string" },
                        parameters: [{
                                name: "myParameter",
                                type: { text: "string" }
                            }],
                        minArgumentCount: 1
                    }, {
                        returnType: { text: "number" },
                        parameters: [{
                                name: "myParameter",
                                type: { text: "number" }
                            }],
                        minArgumentCount: 1
                    }, {
                        returnType: { text: "any" },
                        parameters: [{
                                name: "myParameter",
                                type: { text: "any" }
                            }],
                        minArgumentCount: 1
                    }]
            }]
    });
});

//# sourceMappingURL=callSignatureTests.js.map
