"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("interface extends class tests", function () {
    var code = "\nclass MyBaseClass {\n    name: string;\n}\n\ninterface MyChildInterface extends MyBaseClass {\n    name2: string;\n}\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        classes: [{
                name: "MyBaseClass",
                properties: [{
                        name: "name",
                        type: { text: "string" }
                    }]
            }],
        interfaces: [{
                name: "MyChildInterface",
                extendsTypes: [{
                        text: "MyBaseClass"
                    }],
                properties: [{
                        name: "name2",
                        type: { text: "string" }
                    }]
            }]
    });
});

//# sourceMappingURL=extendsClassTests.js.map
