"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("index signature tests", function () {
    var code = "\ninterface MyInterface {\n    readonly [str: string]: Date;\n    [num: number]: Date;\n}";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        interfaces: [{
                name: "MyInterface",
                indexSignatures: [{
                        isReadonly: true,
                        keyName: "str",
                        keyType: { text: "string" },
                        returnType: { text: "Date" }
                    }, {
                        keyName: "num",
                        keyType: { text: "number" },
                        returnType: { text: "Date" }
                    }]
            }]
    });
});

//# sourceMappingURL=indexSignatureTests.js.map
