"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("interface method", function () {
    var code = "\ninterface MyInterface {\n    // parameters\n    myParameterMethod(myParameter: string, myOptionalParameter?: number): number;\n    myImplicitAnyReturnTypeMethod();\n    myExplicitReturnTypeMethod(): string;\n    myThisTypeMethod(this: string, num: number): void;\n}";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        interfaces: [{
                name: "MyInterface",
                methods: [{
                        name: "myParameterMethod",
                        returnType: { text: "number" },
                        parameters: [{
                                name: "myParameter",
                                type: { text: "string" }
                            }, {
                                name: "myOptionalParameter",
                                type: { text: "number" },
                                isOptional: true
                            }]
                    }, {
                        name: "myImplicitAnyReturnTypeMethod",
                        returnType: { text: "any" }
                    }, {
                        name: "myExplicitReturnTypeMethod",
                        returnType: { text: "string" }
                    }, {
                        name: "myThisTypeMethod",
                        thisType: { text: "string" },
                        parameters: [{
                                name: "num",
                                type: { text: "number" }
                            }]
                    }]
            }]
    });
});

//# sourceMappingURL=methodTests.js.map
