"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("interface new tests", function () {
    var code = "\ninterface MyInterface {\n    new(): MyInterface;\n}\n\ninterface MyInterfaceWithMultipleNew {\n    new(): MyInterface;\n    new<T>(str: string, t: T): MyInterface;\n}\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        interfaces: [{
                name: "MyInterface",
                newSignatures: [{
                        returnType: { text: "MyInterface" }
                    }]
            }, {
                name: "MyInterfaceWithMultipleNew",
                newSignatures: [{
                        returnType: { text: "MyInterface" }
                    }, {
                        typeParameters: [{
                                name: "T"
                            }],
                        parameters: [{
                                name: "str",
                                type: { text: "string" }
                            }, {
                                name: "t",
                                type: { text: "T" }
                            }],
                        returnType: { text: "MyInterface" },
                        minArgumentCount: 2
                    }]
            }]
    });
});

//# sourceMappingURL=newTests.js.map
