"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("interface property tests", function () {
    var code = "\ninterface MyPropertyInterface {\n    readonly myString: string;\n    myAny;\n    myOptional?: string;\n}";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        interfaces: [{
                name: "MyPropertyInterface",
                properties: [{
                        name: "myString",
                        isReadonly: true,
                        type: { text: "string" }
                    }, {
                        name: "myAny",
                        type: { text: "any" }
                    }, {
                        name: "myOptional",
                        type: { text: "string" },
                        isOptional: true
                    }]
            }]
    });
});

//# sourceMappingURL=propertyTests.js.map
