"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("interface type parameters", function () {
    var code = "\ninterface MyInterface<T, U extends string> {\n    tProp: T;\n    uProp: U;\n}";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        interfaces: [{
                name: "MyInterface",
                typeParameters: [{
                        name: "T"
                    }, {
                        name: "U",
                        constraintType: { text: "string" }
                    }],
                properties: [{
                        name: "tProp",
                        type: { text: "T" }
                    }, {
                        name: "uProp",
                        type: { text: "U" }
                    }]
            }]
    });
});

//# sourceMappingURL=typeParameterTests.js.map
