"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
var definitions_1 = require("./../../../definitions");
describe("exported variable tests", function () {
    describe("in definition file", function () {
        var code = "\n    declare module \"definition-var\" {\n        export let myExplicitlyExportedVariable: string;\n        let myImplicitlyExportedVariable: string;\n    }\n    ";
        var def = main_1.getInfoFromString(code);
        testHelpers_1.runFileDefinitionTests(def, {
            namespaces: [{
                    name: "\"definition-var\"",
                    declarationType: definitions_1.NamespaceDeclarationType.Module,
                    isAmbient: true,
                    hasDeclareKeyword: true,
                    variables: [{
                            declarationType: definitions_1.VariableDeclarationType.Let,
                            name: "myExplicitlyExportedVariable",
                            type: { text: "string" },
                            isExported: true,
                            isAmbient: true,
                            hasDeclareKeyword: false
                        }, {
                            declarationType: definitions_1.VariableDeclarationType.Let,
                            name: "myImplicitlyExportedVariable",
                            type: { text: "string" },
                            isExported: true,
                            isAmbient: true,
                            hasDeclareKeyword: false
                        }],
                    exports: [{
                            name: "myExplicitlyExportedVariable"
                        }, {
                            name: "myImplicitlyExportedVariable"
                        }]
                }]
        });
    });
});

//# sourceMappingURL=exportedVariableTests.js.map
