"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
var definitions_1 = require("./../../../definitions");
describe("variable tests", function () {
    var code = "\nvar myImplicitAny;\nvar myExplicitTypeVar: number;\nvar myImplicitTypeVar = \"my string\";\nlet myLet: string;\nconst myConst: number;\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        variables: [{
                name: "myImplicitAny",
                declarationType: definitions_1.VariableDeclarationType.Var,
                type: { text: "any" }
            }, {
                name: "myExplicitTypeVar",
                declarationType: definitions_1.VariableDeclarationType.Var,
                type: { text: "number" }
            }, {
                name: "myImplicitTypeVar",
                declarationType: definitions_1.VariableDeclarationType.Var,
                type: { text: "string" },
                defaultExpression: { text: "\"my string\"" }
            }, {
                name: "myLet",
                declarationType: definitions_1.VariableDeclarationType.Let,
                type: { text: "string" }
            }, {
                name: "myConst",
                declarationType: definitions_1.VariableDeclarationType.Const,
                type: { text: "number" }
            }]
    });
});

//# sourceMappingURL=variableTests.js.map
