"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var assert = require("assert");
var Memoize_1 = require("./../../../utils/decorators/Memoize");
describe("Memoize", function () {
    var MyClass = (function () {
        /* istanbul ignore next */ function MyClass() {
        }
        MyClass.prototype.getNumber = function () {
            return Math.random();
        };
        Object.defineProperty(MyClass.prototype, "value", {
            get: function () {
                return Math.random();
            },
            enumerable: true,
            configurable: true
        });
        __decorate([
            Memoize_1.Memoize
        ], MyClass.prototype, "getNumber", null);
        __decorate([
            Memoize_1.Memoize
        ], MyClass.prototype, "value", null);
        return MyClass;
    }());
    var a = new MyClass();
    var b = new MyClass();
    it("method should be memoized", function () {
        assert.equal(a.getNumber(), a.getNumber());
    });
    it("accessor should be memoized", function () {
        assert.equal(a.value, a.value);
    });
    it("multiple instances shouldn't share values for methods", function () {
        assert.notEqual(a.getNumber(), b.getNumber());
    });
    it("multiple instances shouldn't share values for accessors", function () {
        assert.notEqual(a.value, b.value);
    });
});

//# sourceMappingURL=memoizeTests.js.map
