"use strict";
var fs = require("fs");
var path = require("path");
var FileUtils = (function () {
    /* istanbul ignore next */ function FileUtils() {
    }
    FileUtils.getAbsolutePath = function (filePath) {
        return path.resolve(filePath);
    };
    FileUtils.fileExistsSync = function (filePath) {
        try {
            return fs.statSync(filePath).isFile();
        }
        catch (err) {
            return false;
        }
    };
    FileUtils.standardizeSlashes = function (fileName) {
        return fileName.replace(/\\/g, "/");
    };
    FileUtils.filePathMatches = function (fileName, searchString) {
        var _this = this;
        var splitBySlash = function (p) { return _this.standardizeSlashes(p || "").replace(/^\//, "").split("/"); };
        var fileNameItems = splitBySlash(fileName);
        var searchItems = splitBySlash(searchString);
        if (searchItems.length > fileNameItems.length) {
            return false;
        }
        for (var i = 0; i < searchItems.length; i++) {
            if (searchItems[searchItems.length - i - 1] !== fileNameItems[fileNameItems.length - i - 1]) {
                return false;
            }
        }
        return searchItems.length > 0;
    };
    return FileUtils;
}());
exports.FileUtils = FileUtils;

//# sourceMappingURL=FileUtils.js.map
