"use strict";
var KeyValueCache = (function () {
    function KeyValueCache() {
        this.cacheItems = [];
    }
    KeyValueCache.prototype.getOrCreate = function (key, createFunc) {
        var item = this.get(key);
        if (item == null) {
            item = createFunc();
            this.add(key, item);
        }
        return item;
    };
    KeyValueCache.prototype.get = function (key) {
        // todo: make this O(1) somehow
        for (var _i = 0, _a = this.cacheItems; _i < _a.length; _i++) {
            var cacheItem = _a[_i];
            if (cacheItem.key === key) {
                return cacheItem.value;
            }
        }
        return null;
    };
    KeyValueCache.prototype.add = function (key, value) {
        this.cacheItems.push({ key: key, value: value });
    };
    return KeyValueCache;
}());
exports.KeyValueCache = KeyValueCache;

//# sourceMappingURL=KeyValueCache.js.map
