"use strict";
var Logger = (function () {
    /* istanbul ignore next */ function Logger() {
    }
    Logger.getIsEnabled = function () {
        return this.isEnabled;
    };
    Logger.enable = function () {
        this.toggleEnabled(true);
    };
    Logger.disable = function () {
        this.toggleEnabled(false);
    };
    Logger.toggleEnabled = function (isEnabled) {
        this.isEnabled = isEnabled;
    };
    Logger.setLogFunction = function (logFunction) {
        this.logFunction = logFunction;
    };
    Logger.setWarnFunction = function (warnFunction) {
        this.warnFunction = warnFunction;
    };
    Logger.log = function (message) {
        this.logWithFunction(message, this.logFunction);
    };
    Logger.warn = function (message) {
        this.logWithFunction(message, this.warnFunction);
    };
    Logger.logWithFunction = function (message, func) {
        if (this.isEnabled) {
            func("[ts-type-info]: " + message);
        }
    };
    Logger.isEnabled = false;
    Logger.logFunction = console.log;
    Logger.warnFunction = console.warn;
    return Logger;
}());
exports.Logger = Logger;

//# sourceMappingURL=Logger.js.map
