"use strict";
function getRenameInfosFromNamedImportPart(opts) {
    var currentRenameInfo = opts.currentRenameInfo, namedImportPart = opts.namedImportPart;
    if (currentRenameInfo.getRootNameFrom() === namedImportPart.name) {
        var hasAlias = namedImportPart.alias != null && namedImportPart.name !== namedImportPart.alias;
        if (hasAlias && currentRenameInfo.hasNamespaces()) {
            return [currentRenameInfo.createWithNewFirstNamespace(namedImportPart.alias)];
        }
        else if (!hasAlias) {
            return [currentRenameInfo.createCopy()];
        }
    }
    return [];
}
exports.getRenameInfosFromNamedImportPart = getRenameInfosFromNamedImportPart;

//# sourceMappingURL=getRenameInfosFromNamedImportPart.js.map
