"use strict";
var getRenameInfosFromNamedImportPart_1 = require("./getRenameInfosFromNamedImportPart");
function getRenameInfosFromReExports(opts) {
    var exportedRenameInfos = opts.exportedRenameInfos, searchingModuleSpecifier = opts.searchingModuleSpecifier, file = opts.file;
    var matchingReExports = file.reExports.filter(function (e) { return e.moduleSpecifier === searchingModuleSpecifier; });
    var renameInfos = [];
    matchingReExports.forEach(function (reExportDef) {
        if (reExportDef.namedExports.length > 0) {
            reExportDef.namedExports.forEach(function (namedReExport) {
                exportedRenameInfos.forEach(function (renameInfo) {
                    renameInfos.push.apply(renameInfos, getRenameInfosFromNamedImportPart_1.getRenameInfosFromNamedImportPart({
                        currentRenameInfo: renameInfo,
                        namedImportPart: namedReExport
                    }));
                });
            });
        }
        else {
            renameInfos.push.apply(renameInfos, exportedRenameInfos.filter(function (i) { return !i.isRootDefaultExportOfFile(); }));
        }
    });
    return renameInfos;
}
exports.getRenameInfosFromReExports = getRenameInfosFromReExports;

//# sourceMappingURL=getRenameInfosFromReExports.js.map
