"use strict";
var RenameInfo_1 = require("./RenameInfo");
function getRenameInfosFromVariablesInModule(opts) {
    var moduleDef = opts.moduleDef, currentRenameInfos = opts.currentRenameInfos;
    var newRenameInfos = [];
    moduleDef.variables.forEach(function (varDef) {
        var allRenameInfos = currentRenameInfos.concat(newRenameInfos);
        allRenameInfos.forEach(function (renameInfo) {
            var typeName = varDef.type.text.substr("typeof ".length);
            if (varDef.type.text.indexOf("typeof ") === 0 && renameInfo.fullNameFrom.indexOf(typeName + ".") === 0) {
                var replace = function (name) { return varDef.name + name.substr(typeName.length); };
                newRenameInfos.push(new RenameInfo_1.RenameInfo({
                    fullNameFrom: replace(renameInfo.fullNameFrom),
                    fullNameTo: replace(renameInfo.fullNameTo)
                }));
            }
        });
    });
    return newRenameInfos;
}
exports.getRenameInfosFromVariablesInModule = getRenameInfosFromVariablesInModule;

//# sourceMappingURL=getRenameInfosFromVariablesInModule.js.map
