"use strict";
function renameImportsInFile(opts) {
    var exportedRenameInfos = opts.exportedRenameInfos, searchingModuleSpecifier = opts.searchingModuleSpecifier, fileTo = opts.fileTo;
    var renameInfos = exportedRenameInfos.filter(function (i) { return !i.isRootDefaultExportOfFile() && !i.hasNamespaces(); });
    var matchingImports = fileTo.imports.filter(function (i) { return i.moduleSpecifier === searchingModuleSpecifier; });
    matchingImports.forEach(function (importDef) {
        renameInfos.forEach(function (renameInfo) {
            importDef.namedImports.forEach(function (named) {
                if (named.name === renameInfo.fullNameFrom) {
                    named.name = renameInfo.getRootNameTo();
                }
            });
        });
    });
}
exports.renameImportsInFile = renameImportsInFile;

//# sourceMappingURL=renameImportsInFile.js.map
