"use strict";
var getRenameInfosFromImports_1 = require("./getRenameInfosFromImports");
var getRenameInfosFromVariablesInModule_1 = require("./getRenameInfosFromVariablesInModule");
var getRenameInfosFromDefaultExport_1 = require("./getRenameInfosFromDefaultExport");
var getRenameInfosFromReExports_1 = require("./getRenameInfosFromReExports");
var renameInFile_1 = require("./renameInFile");
var renameImportsInFile_1 = require("./renameImportsInFile");
var renameReExportsInFile_1 = require("./renameReExportsInFile");
function renameInGlobalForExternalModules(opts) {
    var exportedRenameInfos = opts.exportedRenameInfos, exportedFile = opts.exportedFile, globalDef = opts.globalDef;
    globalDef.files.filter(function (f) { return f !== exportedFile; }).forEach(function (f) {
        var searchingModuleSpecifier = f.getModuleSpecifierToFile(exportedFile);
        var importedRenameInfos = getRenameInfosFromImports_1.getRenameInfosFromImports({
            exportedRenameInfos: exportedRenameInfos,
            file: f,
            searchingModuleSpecifier: searchingModuleSpecifier
        });
        var fileLocalRenameInfos = importedRenameInfos.concat(getRenameInfosFromVariablesInModule_1.getRenameInfosFromVariablesInModule({
            moduleDef: exportedFile,
            currentRenameInfos: importedRenameInfos
        }));
        var newExportedRenameInfos = getRenameInfosFromDefaultExport_1.getRenameInfosFromDefaultExport({ currentRenameInfos: fileLocalRenameInfos, file: f }).concat(getRenameInfosFromReExports_1.getRenameInfosFromReExports({ exportedRenameInfos: exportedRenameInfos, file: f, searchingModuleSpecifier: searchingModuleSpecifier }));
        renameImportsInFile_1.renameImportsInFile({
            exportedRenameInfos: exportedRenameInfos,
            searchingModuleSpecifier: searchingModuleSpecifier,
            fileTo: f
        });
        renameReExportsInFile_1.renameReExportsInFile({
            exportedRenameInfos: exportedRenameInfos,
            searchingModuleSpecifier: searchingModuleSpecifier,
            fileTo: f
        });
        renameInFile_1.renameInFile(importedRenameInfos, f);
        if (newExportedRenameInfos.length > 0) {
            renameInGlobalForExternalModules({
                exportedRenameInfos: newExportedRenameInfos,
                exportedFile: f,
                globalDef: globalDef
            });
        }
    });
}
exports.renameInGlobalForExternalModules = renameInGlobalForExternalModules;

//# sourceMappingURL=renameInGlobalForExternalModules.js.map
