"use strict";
var logError_1 = require("./logError");
/* istanbul ignore next */
function tryGet(objOrString, attemptToGet, onSuccess) {
    var def = null;
    try {
        def = attemptToGet();
    }
    catch (ex) {
        if (typeof objOrString === "string") {
            logError_1.logError(objOrString, ex);
        }
        else {
            logError_1.logError(objOrString.getName(), ex);
        }
    }
    if (onSuccess instanceof Function && def != null) {
        onSuccess(def);
    }
    return def;
}
exports.tryGet = tryGet;

//# sourceMappingURL=tryGet.js.map
