"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var TypeParametersWriter_1 = require("./TypeParametersWriter");
var TypeWriter_1 = require("./TypeWriter");
var ParametersWriter_1 = require("./ParametersWriter");
var BaseDefinitionWriter_1 = require("./BaseDefinitionWriter");
var CallSignatureWriter = (function (_super) {
    __extends(CallSignatureWriter, _super);
    function CallSignatureWriter() {
        _super.apply(this, arguments);
        this.typeParametersWriter = new TypeParametersWriter_1.TypeParametersWriter(this.writer);
        this.typeWriter = new TypeWriter_1.TypeWriter(this.writer);
        this.parametersWriter = new ParametersWriter_1.ParametersWriter(this.writer);
    }
    CallSignatureWriter.prototype.writeDefault = function (def, flags) {
        this.typeParametersWriter.write(def.typeParameters, flags);
        this.parametersWriter.write(def, flags);
        this.typeWriter.writeWithColon(def.returnType);
        this.writer.write(";").newLine();
    };
    return CallSignatureWriter;
}(BaseDefinitionWriter_1.BaseDefinitionWriter));
exports.CallSignatureWriter = CallSignatureWriter;

//# sourceMappingURL=CallSignatureWriter.js.map
