"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var WriteFlags_1 = require("./../WriteFlags");
var ParametersWriter_1 = require("./ParametersWriter");
var BaseDefinitionWriter_1 = require("./BaseDefinitionWriter");
var FunctionBodyWriter_1 = require("./FunctionBodyWriter");
var ScopeWriter_1 = require("./ScopeWriter");
var ClassConstructorWriter = (function (_super) {
    __extends(ClassConstructorWriter, _super);
    function ClassConstructorWriter() {
        _super.apply(this, arguments);
        this.parametersWriter = new ParametersWriter_1.ParametersWriter(this.writer);
        this.functionBodyWriter = new FunctionBodyWriter_1.FunctionBodyWriter(this.writer);
        this.scopeWriter = new ScopeWriter_1.ScopeWriter(this.writer);
    }
    ClassConstructorWriter.shouldWriteConstructor = function (def, flags) {
        return (def.parameters.length > 0 || FunctionBodyWriter_1.FunctionBodyWriter.willWriteFunctionBody(def, flags) || flags & WriteFlags_1.WriteFlags.HideFunctionBodies);
    };
    ClassConstructorWriter.prototype.writeDefault = function (def, flags) {
        this.scopeWriter.write(def.scope);
        this.writer.spaceIfLastNotSpace();
        this.writer.write("constructor");
        this.parametersWriter.write(def, flags);
        this.functionBodyWriter.write(def, flags);
    };
    return ClassConstructorWriter;
}(BaseDefinitionWriter_1.BaseDefinitionWriter));
exports.ClassConstructorWriter = ClassConstructorWriter;

//# sourceMappingURL=ClassConstructorWriter.js.map
