"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var WriteFlags_1 = require("./../WriteFlags");
var utils_1 = require("./../utils");
var BaseWriter_1 = require("./BaseWriter");
var ExpressionWriter = (function (_super) {
    __extends(ExpressionWriter, _super);
    function ExpressionWriter() {
        _super.apply(this, arguments);
    }
    ExpressionWriter.willWriteDefaultExpression = function (def, flags) {
        return ((flags & WriteFlags_1.WriteFlags.HideExpressions) === 0 &&
            def.defaultExpression != null &&
            !utils_1.StringUtils.isNullOrWhiteSpace(def.defaultExpression.text));
    };
    ExpressionWriter.prototype.writeWithEqualsSign = function (def) {
        if (def != null) {
            this.writer.write(" = ");
            this.write(def);
        }
    };
    ExpressionWriter.prototype.write = function (def) {
        if (def != null) {
            this.writer.write(def.text);
        }
    };
    return ExpressionWriter;
}(BaseWriter_1.BaseWriter));
exports.ExpressionWriter = ExpressionWriter;

//# sourceMappingURL=ExpressionWriter.js.map
