"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var BaseWriter_1 = require("./BaseWriter");
var ExpressionWriter_1 = require("./ExpressionWriter");
var ExtendsImplementsClauseWriter = (function (_super) {
    __extends(ExtendsImplementsClauseWriter, _super);
    function ExtendsImplementsClauseWriter() {
        _super.apply(this, arguments);
        this.expressionWriter = new ExpressionWriter_1.ExpressionWriter(this.writer);
    }
    ExtendsImplementsClauseWriter.prototype.writeExtends = function (def) {
        this.writeClause({
            word: "extends",
            expressions: def.extendsTypes
        });
        return this;
    };
    ExtendsImplementsClauseWriter.prototype.writeImplements = function (def) {
        this.writeClause({
            word: "implements",
            expressions: def.implementsTypes
        });
        return this;
    };
    ExtendsImplementsClauseWriter.prototype.writeClause = function (obj) {
        if (obj.expressions.length > 0) {
            this.writer.write(" " + obj.word + " ");
            this.writeExpressions(obj.expressions);
        }
    };
    ExtendsImplementsClauseWriter.prototype.writeExpressions = function (expressions) {
        var _this = this;
        expressions.forEach(function (t, i) {
            if (i !== 0) {
                _this.writer.write(", ");
            }
            t.text = _this.toGenericArrayIfArray(t.text);
            _this.expressionWriter.write(t);
        });
    };
    ExtendsImplementsClauseWriter.prototype.toGenericArrayIfArray = function (str) {
        return str.replace(/(.*)\[\]$/, "Array<$1>");
    };
    return ExtendsImplementsClauseWriter;
}(BaseWriter_1.BaseWriter));
exports.ExtendsImplementsClauseWriter = ExtendsImplementsClauseWriter;

//# sourceMappingURL=ExtendsImplementsClauseWriter.js.map
