"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var BaseDefinitionWriter_1 = require("./BaseDefinitionWriter");
var ImportWriter_1 = require("./ImportWriter");
var ReExportWriter_1 = require("./ReExportWriter");
var ModuledWriter_1 = require("./ModuledWriter");
var FileWriter = (function (_super) {
    __extends(FileWriter, _super);
    function FileWriter() {
        _super.apply(this, arguments);
        this.importWriter = new ImportWriter_1.ImportWriter(this.writer);
        this.reExportWriter = new ReExportWriter_1.ReExportWriter(this.writer);
        this.moduledWriter = new ModuledWriter_1.ModuledWriter(this.writer);
    }
    FileWriter.prototype.writeDefault = function (def, flags) {
        this.writeImports(def, flags);
        this.writer.newLine();
        this.writeReExports(def, flags);
        this.writer.newLine();
        this.moduledWriter.write(def, flags);
        this.writeDefaultExportExpression(def.defaultExportExpression);
    };
    FileWriter.prototype.writeImports = function (fileDef, flags) {
        var _this = this;
        fileDef.imports.forEach(function (importDef) {
            _this.importWriter.write(importDef, flags);
        });
    };
    FileWriter.prototype.writeReExports = function (fileDef, flags) {
        var _this = this;
        fileDef.reExports.forEach(function (reExportDef) {
            _this.reExportWriter.write(reExportDef, flags);
        });
    };
    FileWriter.prototype.writeDefaultExportExpression = function (expression) {
        if (expression != null) {
            this.writer.newLine();
            this.writer.write("export default ")
                .write(expression.text)
                .write(";")
                .newLine();
        }
    };
    return FileWriter;
}(BaseDefinitionWriter_1.BaseDefinitionWriter));
exports.FileWriter = FileWriter;

//# sourceMappingURL=FileWriter.js.map
