"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var definitions_1 = require("./../definitions");
var WriteFlags_1 = require("./../WriteFlags");
var BaseWriter_1 = require("./BaseWriter");
var FunctionBodyWriter = (function (_super) {
    __extends(FunctionBodyWriter, _super);
    function FunctionBodyWriter() {
        _super.apply(this, arguments);
    }
    FunctionBodyWriter.willWriteFunctionBody = function (def, flags) {
        if (def instanceof definitions_1.InterfaceMethodDefinition) {
            return false;
        }
        else {
            var isOnWriteFunctionBodyDefined = typeof def.onWriteFunctionBody === "function";
            var shouldHideFunctionBodies = (flags & WriteFlags_1.WriteFlags.HideFunctionBodies) !== 0;
            var isAmbient = def instanceof definitions_1.FunctionDefinition && def.isAmbient;
            var isAbstract = def.isAbstract || false;
            var suggestedToHideFunctionBody = shouldHideFunctionBodies || isAmbient || isAbstract;
            return isOnWriteFunctionBodyDefined || !suggestedToHideFunctionBody;
        }
    };
    FunctionBodyWriter.prototype.write = function (def, flags) {
        if (FunctionBodyWriter.willWriteFunctionBody(def, flags)) {
            this.writeFunctionBody(def);
        }
        else {
            this.writeSemiColon();
        }
    };
    FunctionBodyWriter.prototype.writeSemiColon = function () {
        this.writer.write(";").newLine();
    };
    FunctionBodyWriter.prototype.writeFunctionBody = function (def) {
        var _this = this;
        this.writer.block(function () {
            if (typeof def.onWriteFunctionBody === "function") {
                def.onWriteFunctionBody(_this.writer);
            }
        });
    };
    return FunctionBodyWriter;
}(BaseWriter_1.BaseWriter));
exports.FunctionBodyWriter = FunctionBodyWriter;

//# sourceMappingURL=FunctionBodyWriter.js.map
