"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var BaseWriter_1 = require("./BaseWriter");
var FunctionBodyWriter_1 = require("./FunctionBodyWriter");
var TypeWriter_1 = require("./TypeWriter");
var FunctionReturnTypeWriter = (function (_super) {
    __extends(FunctionReturnTypeWriter, _super);
    function FunctionReturnTypeWriter() {
        _super.apply(this, arguments);
        this.typeWriter = new TypeWriter_1.TypeWriter(this.writer);
    }
    FunctionReturnTypeWriter.prototype.write = function (def, flags) {
        if (def.userDefinedTypeGuard != null) {
            this.writer.write(": " + (def.userDefinedTypeGuard.parameterName || "this") + " is " + def.userDefinedTypeGuard.type.text);
        }
        else if (!FunctionBodyWriter_1.FunctionBodyWriter.willWriteFunctionBody(def, flags) || def.overloadSignatures.length > 0) {
            this.typeWriter.writeWithColon(def.returnType);
        }
    };
    return FunctionReturnTypeWriter;
}(BaseWriter_1.BaseWriter));
exports.FunctionReturnTypeWriter = FunctionReturnTypeWriter;

//# sourceMappingURL=FunctionReturnTypeWriter.js.map
