"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var definitions_1 = require("./../definitions");
var BaseDefinitionWriter_1 = require("./BaseDefinitionWriter");
var NamespaceWriter = (function (_super) {
    __extends(NamespaceWriter, _super);
    function NamespaceWriter(writer, moduledWriter) {
        _super.call(this, writer);
        this.moduledWriter = moduledWriter;
    }
    NamespaceWriter.prototype.writeDefault = function (def, flags) {
        var _this = this;
        this.writeExportKeyword(def, flags);
        this.writeDeclareKeyword(def);
        this.writer.write(this.getDeclarationTypeAsString(def.declarationType)).write(" " + def.name).block(function () {
            _this.moduledWriter.write(def, flags);
        });
    };
    NamespaceWriter.prototype.getDeclarationTypeAsString = function (declarationType) {
        switch (declarationType) {
            case definitions_1.NamespaceDeclarationType.Module:
                return "module";
            case definitions_1.NamespaceDeclarationType.Namespace:
                return "namespace";
            default:
                throw "Not implemented NamespaceDeclarationType: " + declarationType;
        }
    };
    return NamespaceWriter;
}(BaseDefinitionWriter_1.BaseDefinitionWriter));
exports.NamespaceWriter = NamespaceWriter;

//# sourceMappingURL=NamespaceWriter.js.map
