"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var ExpressionWriter_1 = require("./ExpressionWriter");
var TypeWriter_1 = require("./TypeWriter");
var BaseDefinitionWriter_1 = require("./BaseDefinitionWriter");
var ParameterWithDestructuringWriter = (function (_super) {
    __extends(ParameterWithDestructuringWriter, _super);
    function ParameterWithDestructuringWriter() {
        _super.apply(this, arguments);
        this.expressionWriter = new ExpressionWriter_1.ExpressionWriter(this.writer);
        this.typeWriter = new TypeWriter_1.TypeWriter(this.writer);
    }
    ParameterWithDestructuringWriter.prototype.writeDefault = function (param, flags) {
        this.writeLeftSide(param, flags);
        this.writer.write(": ");
        this.writeRightSide(param);
    };
    ParameterWithDestructuringWriter.prototype.writeLeftSide = function (param, flags) {
        var _this = this;
        this.surroundInBrances(function () {
            param.destructuringProperties.forEach(function (p, i) {
                _this.writer.conditionalWrite(i > 0, ", ");
                _this.writer.write(p.name);
                if (ExpressionWriter_1.ExpressionWriter.willWriteDefaultExpression(p, flags) && p.defaultExpression != null) {
                    _this.expressionWriter.writeWithEqualsSign(p.defaultExpression);
                }
            });
        });
    };
    ParameterWithDestructuringWriter.prototype.writeRightSide = function (param) {
        var _this = this;
        this.surroundInBrances(function () {
            param.destructuringProperties.forEach(function (p, i) {
                _this.writer.conditionalWrite(i > 0, " ");
                _this.writer.write(p.name);
                _this.writer.conditionalWrite(p.isOptional, "?");
                _this.typeWriter.writeWithColon(p.type);
                _this.writer.write(";");
            });
        });
    };
    ParameterWithDestructuringWriter.prototype.surroundInBrances = function (func) {
        this.writer.write("{ ");
        func();
        this.writer.write(" }");
    };
    return ParameterWithDestructuringWriter;
}(BaseDefinitionWriter_1.BaseDefinitionWriter));
exports.ParameterWithDestructuringWriter = ParameterWithDestructuringWriter;

//# sourceMappingURL=ParameterWithDestructuringWriter.js.map
