"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var WriteFlags_1 = require("./../WriteFlags");
var BaseDefinitionWriter_1 = require("./BaseDefinitionWriter");
var TypeWithDefaultExpressionWriter_1 = require("./TypeWithDefaultExpressionWriter");
var ParameterWriter = (function (_super) {
    __extends(ParameterWriter, _super);
    function ParameterWriter() {
        _super.apply(this, arguments);
        this.typeWithDefaultExpressionWriter = new TypeWithDefaultExpressionWriter_1.TypeWithDefaultExpressionWriter(this.writer);
    }
    ParameterWriter.prototype.writeDefault = function (param, flags) {
        this.writeRestParameter(param);
        this.writer.write(param.name);
        this.writeIsOptional(param, flags);
        this.typeWithDefaultExpressionWriter.write(param, flags);
    };
    ParameterWriter.prototype.writeRestParameter = function (param) {
        if (param.isRestParameter) {
            this.writer.write("...");
        }
    };
    ParameterWriter.prototype.writeIsOptional = function (param, flags) {
        var isOptionalNotRest = param.isOptional && !param.isRestParameter;
        var willWriteDefaultExpression = param.defaultExpression != null && (flags & WriteFlags_1.WriteFlags.HideExpressions) !== WriteFlags_1.WriteFlags.HideExpressions;
        if (isOptionalNotRest && !willWriteDefaultExpression) {
            this.writer.write("?");
        }
    };
    return ParameterWriter;
}(BaseDefinitionWriter_1.BaseDefinitionWriter));
exports.ParameterWriter = ParameterWriter;

//# sourceMappingURL=ParameterWriter.js.map
