"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var BaseDefinitionWriter_1 = require("./BaseDefinitionWriter");
var ReExportWriter = (function (_super) {
    __extends(ReExportWriter, _super);
    function ReExportWriter() {
        _super.apply(this, arguments);
    }
    ReExportWriter.prototype.writeDefault = function (def) {
        this.writer.write("export ");
        if ((def.namedExports || []).length > 0) {
            this.writeNamedReExports(def);
        }
        else {
            this.writer.write("*");
        }
        this.writer.write(" from ");
        this.writer.write("\"" + def.moduleSpecifier + "\";");
        this.writer.newLine();
    };
    ReExportWriter.prototype.writeNamedReExports = function (def) {
        var _this = this;
        this.writer.write("{");
        (def.namedExports || []).forEach(function (namedExport, i) {
            var alias = namedExport.alias, name = namedExport.name;
            _this.writer.conditionalWrite(i !== 0, ", ");
            if (alias != null && name !== alias) {
                _this.writer.write(name + " as " + alias);
            }
            else {
                _this.writer.write("" + name);
            }
        });
        this.writer.write("}");
    };
    return ReExportWriter;
}(BaseDefinitionWriter_1.BaseDefinitionWriter));
exports.ReExportWriter = ReExportWriter;

//# sourceMappingURL=ReExportWriter.js.map
