"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var BaseWriter_1 = require("./BaseWriter");
var TypeParameterWriter_1 = require("./TypeParameterWriter");
var TypeParametersWriter = (function (_super) {
    __extends(TypeParametersWriter, _super);
    function TypeParametersWriter() {
        _super.apply(this, arguments);
        this.typeParameterWriter = new TypeParameterWriter_1.TypeParameterWriter(this.writer);
    }
    TypeParametersWriter.prototype.write = function (typeParameters, flags) {
        if (typeParameters.length > 0) {
            this.writer.write("<");
            this.writeTypeParameters(typeParameters, flags);
            this.writer.write(">");
        }
    };
    TypeParametersWriter.prototype.writeTypeParameters = function (typeParameters, flags) {
        var _this = this;
        typeParameters.forEach(function (p, i) {
            if (i !== 0) {
                _this.writer.write(", ");
            }
            _this.typeParameterWriter.write(p, flags);
        });
    };
    return TypeParametersWriter;
}(BaseWriter_1.BaseWriter));
exports.TypeParametersWriter = TypeParametersWriter;

//# sourceMappingURL=TypeParametersWriter.js.map
