"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var TypeWriter_1 = require("./TypeWriter");
var ExpressionWriter_1 = require("./ExpressionWriter");
var BaseWriter_1 = require("./BaseWriter");
var TypeWithDefaultExpressionWriter = (function (_super) {
    __extends(TypeWithDefaultExpressionWriter, _super);
    function TypeWithDefaultExpressionWriter() {
        _super.apply(this, arguments);
        this.typeWriter = new TypeWriter_1.TypeWriter(this.writer);
        this.expressionWriter = new ExpressionWriter_1.ExpressionWriter(this.writer);
    }
    TypeWithDefaultExpressionWriter.prototype.write = function (def, flags) {
        var shouldWriteDefaultExpression = this.getShouldWriteDefaultExpression(def, flags);
        if (shouldWriteDefaultExpression) {
            this.writeDefaultExpression(def);
        }
        else {
            this.writeType(def);
        }
    };
    TypeWithDefaultExpressionWriter.prototype.writeWithOptionalCheck = function (def, flags) {
        var shouldWriteDefaultExpression = this.getShouldWriteDefaultExpression(def, flags);
        if (!shouldWriteDefaultExpression || def.isOptional === true) {
            this.writeType(def);
        }
        if (shouldWriteDefaultExpression) {
            this.writeDefaultExpression(def);
        }
    };
    TypeWithDefaultExpressionWriter.prototype.getShouldWriteDefaultExpression = function (def, flags) {
        return ExpressionWriter_1.ExpressionWriter.willWriteDefaultExpression(def, flags);
    };
    TypeWithDefaultExpressionWriter.prototype.writeType = function (def) {
        this.typeWriter.writeWithColon(def.type);
    };
    TypeWithDefaultExpressionWriter.prototype.writeDefaultExpression = function (def) {
        this.expressionWriter.writeWithEqualsSign(def.defaultExpression);
    };
    return TypeWithDefaultExpressionWriter;
}(BaseWriter_1.BaseWriter));
exports.TypeWithDefaultExpressionWriter = TypeWithDefaultExpressionWriter;

//# sourceMappingURL=TypeWithDefaultExpressionWriter.js.map
