﻿import * as path from "path";
import * as fs from "fs";
import {getInfoFromFiles, createFile} from "./../main";

export function generateStrictStructures() {
    const result = getInfoFromFiles([path.join(__dirname, "../../src/structures.ts")]);
    const fileDefForCreate = createFile();

    result.files.filter(f => f.fileName.indexOf("structures") >= 0).forEach(f => {
        f.interfaces.forEach(i => {
            result.renameDefinitionAs(i, "Strict" + i.name);

            i.properties.forEach(p => {
                p.isOptional = false;
            });

            fileDefForCreate.interfaces.push(i);
        });
    });

    fileDefForCreate.addImport({
        defaultImportName: "CodeBlockWriter",
        moduleSpecifier: "code-block-writer"
    });

    fileDefForCreate.onBeforeWrite = writer => {
        writer.writeLine("// autogenerated file by gulp generate-strict-structures - DO NOT EDIT!!!").newLine();
    };

    fs.writeFile(path.join(__dirname, "../../src/strictStructures.ts"), fileDefForCreate.write());
}
